-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.5.24-log


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema evaltics
--

CREATE DATABASE IF NOT EXISTS evaltics;
USE evaltics;

--
-- Definition of table `alumno`
--

DROP TABLE IF EXISTS `alumno`;
CREATE TABLE `alumno` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `dni` varchar(16) NOT NULL,
  `primerNombre` varchar(64) NOT NULL,
  `segundoNombre` varchar(64) DEFAULT NULL,
  `apellidoPaterno` varchar(64) NOT NULL,
  `apellidoMaterno` varchar(64) DEFAULT NULL,
  `direccion` tinytext NOT NULL,
  `telefono` varchar(64) NOT NULL,
  `movilA` varchar(64) DEFAULT NULL,
  `usuario` varchar(128) NOT NULL,
  `clave` varchar(256) NOT NULL,
  `email` varchar(128) NOT NULL,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=23 DEFAULT CHARSET=latin1;

--
-- Definition of table `asignatura`
--

DROP TABLE IF EXISTS `asignatura`;
CREATE TABLE `asignatura` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `codigo` varchar(16) NOT NULL,
  `siglas` varchar(48) NOT NULL,
  `nombre` varchar(128) NOT NULL,
  `descripcion` text NOT NULL,
  `creditos_teoria` float DEFAULT NULL,
  `creditos_laboratorio` float DEFAULT NULL,
  `centro_id` int(10) unsigned DEFAULT NULL,
  `curso_id` int(10) unsigned DEFAULT NULL,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FKCFD175739DBAB1DF` (`curso_id`),
  KEY `FKCFD17573C8F2CA95` (`centro_id`),
  CONSTRAINT `FKCFD175739DBAB1DF` FOREIGN KEY (`curso_id`) REFERENCES `curso` (`id`),
  CONSTRAINT `FKCFD17573C8F2CA95` FOREIGN KEY (`centro_id`) REFERENCES `centro` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;

--
-- Definition of table `autor`
--

DROP TABLE IF EXISTS `autor`;
CREATE TABLE `autor` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `dni` varchar(16) NOT NULL,
  `primerNombre` varchar(64) NOT NULL,
  `segundoNombre` varchar(64) DEFAULT NULL,
  `apellidoPaterno` varchar(64) NOT NULL,
  `apellidoMaterno` varchar(64) DEFAULT NULL,
  `direccion` tinytext NOT NULL,
  `telefono` varchar(64) NOT NULL,
  `movilA` varchar(64) DEFAULT NULL,
  `usuario` varchar(128) NOT NULL,
  `clave` varchar(256) NOT NULL,
  `email` varchar(128) NOT NULL,
  `version` int(10) unsigned DEFAULT NULL,
  `despacho` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=latin1;


--
-- Definition of table `centro`
--

DROP TABLE IF EXISTS `centro`;
CREATE TABLE `centro` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(128) NOT NULL,
  `siglas` varchar(48) NOT NULL,
  `descripcion` text,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=52 DEFAULT CHARSET=latin1;


--
-- Definition of table `curso`
--

DROP TABLE IF EXISTS `curso`;
CREATE TABLE `curso` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(256) NOT NULL,
  `descripcion` varchar(1024) NOT NULL,
  `version` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;


--
-- Definition of table `evaluacion`
--

DROP TABLE IF EXISTS `evaluacion`;
CREATE TABLE `evaluacion` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asignatura_id` int(10) unsigned NOT NULL,
  `tema_id` int(10) unsigned NOT NULL,
  `autor_id` int(10) unsigned DEFAULT NULL,
  `titulo` varchar(45) NOT NULL,
  `fecha_apertura` datetime DEFAULT NULL,
  `fecha_cierre` datetime DEFAULT NULL,
  `valor` float DEFAULT NULL,
  `grado_confianza` tinyint(3) unsigned DEFAULT '0',
  `publicado` tinyint(1) NOT NULL DEFAULT '0',
  `n_preguntas` int(10) unsigned NOT NULL,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK33244CED8DBF8AF2` (`tema_id`),
  KEY `FK33244CED46D00255` (`asignatura_id`),
  KEY `FK33244CEDD10EE07F` (`autor_id`),
  CONSTRAINT `FK33244CED46D00255` FOREIGN KEY (`asignatura_id`) REFERENCES `asignatura` (`id`),
  CONSTRAINT `FK33244CED8DBF8AF2` FOREIGN KEY (`tema_id`) REFERENCES `tema` (`id`),
  CONSTRAINT `FK33244CEDD10EE07F` FOREIGN KEY (`autor_id`) REFERENCES `autor` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;

--
-- Definition of table `evaluacion_alumno`
--

DROP TABLE IF EXISTS `evaluacion_alumno`;
CREATE TABLE `evaluacion_alumno` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `evaluacion_id` int(10) unsigned NOT NULL,
  `fecha` datetime NOT NULL,
  `nota` float DEFAULT '0',
  `comentarios` tinytext,
  `matricula_alumno_id` int(10) unsigned NOT NULL,
  `matricula_asignatura_id` int(10) unsigned NOT NULL,
  `finalizado` tinyint(1) NOT NULL DEFAULT '0',
  `corregido` tinyint(1) NOT NULL DEFAULT '0',
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FKE439096F5E45D54` (`matricula_asignatura_id`),
  KEY `FKE439096EB68C51F` (`evaluacion_id`),
  KEY `FKE4390966DEF34B4` (`matricula_alumno_id`),
  CONSTRAINT `FKE4390966DEF34B4` FOREIGN KEY (`matricula_alumno_id`) REFERENCES `alumno` (`id`),
  CONSTRAINT `FKE439096EB68C51F` FOREIGN KEY (`evaluacion_id`) REFERENCES `evaluacion` (`id`),
  CONSTRAINT `FKE439096F5E45D54` FOREIGN KEY (`matricula_asignatura_id`) REFERENCES `asignatura` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;

--
-- Definition of table `evaluacion_pregunta`
--

DROP TABLE IF EXISTS `evaluacion_pregunta`;
CREATE TABLE `evaluacion_pregunta` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `evaluacion_id` int(10) unsigned NOT NULL,
  `tema_id` int(10) unsigned NOT NULL,
  `pregunta_id` int(10) unsigned NOT NULL,
  `dificultad` float DEFAULT NULL,
  `pregunta_valor` float DEFAULT NULL,
  `penalizacion` float DEFAULT NULL,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FKC399E9FC8DBF8AF2` (`tema_id`),
  KEY `FKC399E9FC487C853F` (`pregunta_id`),
  KEY `FKC399E9FCEB68C51F` (`evaluacion_id`),
  CONSTRAINT `FKC399E9FC487C853F` FOREIGN KEY (`pregunta_id`) REFERENCES `pregunta` (`id`),
  CONSTRAINT `FKC399E9FC8DBF8AF2` FOREIGN KEY (`tema_id`) REFERENCES `tema` (`id`),
  CONSTRAINT `FKC399E9FCEB68C51F` FOREIGN KEY (`evaluacion_id`) REFERENCES `evaluacion` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=latin1;

--
-- Definition of table `grado_confianza`
--

DROP TABLE IF EXISTS `grado_confianza`;
CREATE TABLE `grado_confianza` (
  `id` bigint(20) NOT NULL,
  `nombre` varchar(128) NOT NULL,
  `orden` int(11) DEFAULT NULL,
  `valor` float DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `grado_confianza`
--

/*!40000 ALTER TABLE `grado_confianza` DISABLE KEYS */;
/*!40000 ALTER TABLE `grado_confianza` ENABLE KEYS */;


--
-- Definition of table `matricula`
--

DROP TABLE IF EXISTS `matricula`;
CREATE TABLE `matricula` (
  `alumno_id` int(10) unsigned NOT NULL,
  `asignatura_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`alumno_id`,`asignatura_id`),
  KEY `FK3E46FD7E46D00255` (`asignatura_id`),
  KEY `FK3E46FD7EDAAF8235` (`alumno_id`),
  CONSTRAINT `FK3E46FD7E46D00255` FOREIGN KEY (`asignatura_id`) REFERENCES `asignatura` (`id`),
  CONSTRAINT `FK3E46FD7EDAAF8235` FOREIGN KEY (`alumno_id`) REFERENCES `alumno` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


--
-- Definition of table `pregunta`
--

DROP TABLE IF EXISTS `pregunta`;
CREATE TABLE `pregunta` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `fecha_creacion` datetime NOT NULL,
  `fecha_modificacion` datetime NOT NULL,
  `titulo` varchar(128) NOT NULL,
  `codigo` varchar(512) NOT NULL,
  `enunciado` text NOT NULL,
  `palabras_clave` text,
  `dificultad` float NOT NULL,
  `tipo_id` int(10) unsigned NOT NULL,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FKB345CAEA6C9B7989` (`tipo_id`),
  CONSTRAINT `FKB345CAEA6C9B7989` FOREIGN KEY (`tipo_id`) REFERENCES `tipo_pregunta` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=91 DEFAULT CHARSET=latin1;

--
-- Definition of table `pregunta_respuesta`
--

DROP TABLE IF EXISTS `pregunta_respuesta`;
CREATE TABLE `pregunta_respuesta` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `pregunta_id` int(10) unsigned NOT NULL,
  `refuerzo_positivo` text,
  `refuerzo_negativo` text,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

--
-- Definition of table `pregunta_respuesta_om`
--

DROP TABLE IF EXISTS `pregunta_respuesta_om`;
CREATE TABLE `pregunta_respuesta_om` (
  `respuesta_id` int(10) unsigned NOT NULL,
  `respuesta` text,
  `correcta` tinyint(3) unsigned DEFAULT '0',
  PRIMARY KEY (`respuesta_id`) USING BTREE,
  KEY `FK671D19F232ADC29F` (`respuesta_id`),
  CONSTRAINT `FK671D19F232ADC29F` FOREIGN KEY (`respuesta_id`) REFERENCES `pregunta_respuesta` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


--
-- Definition of table `pregunta_respuesta_rl`
--

DROP TABLE IF EXISTS `pregunta_respuesta_rl`;
CREATE TABLE `pregunta_respuesta_rl` (
  `respuesta_id` int(10) unsigned NOT NULL,
  `respuesta_posible` text,
  PRIMARY KEY (`respuesta_id`),
  KEY `FK671D1A4E32ADC29F` (`respuesta_id`),
  CONSTRAINT `FK671D1A4E32ADC29F` FOREIGN KEY (`respuesta_id`) REFERENCES `pregunta_respuesta` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


--
-- Definition of table `pregunta_respuesta_vf`
--

DROP TABLE IF EXISTS `pregunta_respuesta_vf`;
CREATE TABLE `pregunta_respuesta_vf` (
  `respuesta_id` int(10) unsigned NOT NULL,
  `correcta` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`respuesta_id`),
  KEY `FK671D1AC432ADC29F` (`respuesta_id`),
  CONSTRAINT `FK671D1AC432ADC29F` FOREIGN KEY (`respuesta_id`) REFERENCES `pregunta_respuesta` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


--
-- Definition of table `pregunta_tema`
--

DROP TABLE IF EXISTS `pregunta_tema`;
CREATE TABLE `pregunta_tema` (
  `pregunta_id` int(10) unsigned NOT NULL,
  `tema_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`pregunta_id`,`tema_id`) USING BTREE,
  KEY `FKD78773FA8DBF8AF2` (`tema_id`),
  CONSTRAINT `FKD78773FA8DBF8AF2` FOREIGN KEY (`tema_id`) REFERENCES `tema` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


--
-- Definition of table `respuesta_alumno`
--

DROP TABLE IF EXISTS `respuesta_alumno`;
CREATE TABLE `respuesta_alumno` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `evaluacion_alumno_id` int(10) unsigned NOT NULL,
  `evaluacion_pregunta_id` int(10) unsigned NOT NULL,
  `vf` tinyint(1) DEFAULT NULL,
  `om` int(10) unsigned DEFAULT NULL,
  `rl` text,
  `nota` float DEFAULT NULL,
  `grado_confianza` int(10) unsigned DEFAULT NULL,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK8E562E6358EF587A` (`evaluacion_alumno_id`),
  KEY `FK8E562E6343BF76BA` (`evaluacion_pregunta_id`),
  CONSTRAINT `FK8E562E6343BF76BA` FOREIGN KEY (`evaluacion_pregunta_id`) REFERENCES `evaluacion_pregunta` (`id`),
  CONSTRAINT `FK8E562E6358EF587A` FOREIGN KEY (`evaluacion_alumno_id`) REFERENCES `evaluacion_alumno` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;


--
-- Definition of table `tema`
--

DROP TABLE IF EXISTS `tema`;
CREATE TABLE `tema` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(128) NOT NULL,
  `numero_tema` int(10) unsigned NOT NULL,
  `descripcion` text NOT NULL,
  `asignatura_id` int(10) unsigned NOT NULL,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `tema_uniq_asignatura_numero_tema` (`numero_tema`,`asignatura_id`)
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARSET=latin1;


--
-- Definition of table `tipo_pregunta`
--

DROP TABLE IF EXISTS `tipo_pregunta`;
CREATE TABLE `tipo_pregunta` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `codigo` varchar(5) NOT NULL,
  `nombre` varchar(128) NOT NULL,
  `descripcion` text NOT NULL,
  `version` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `tipo_pregunta_nombre_uniq` (`nombre`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `tipo_pregunta`
--

/*!40000 ALTER TABLE `tipo_pregunta` DISABLE KEYS */;
INSERT INTO `tipo_pregunta` VALUES  (1,'VF','Verdadero/Falso','Escoger entre dos respuesta, una es correcta y la otra no',3),
 (3,'OM','Opción múltiple','Escoger entre una de las opciones posibles, una de las cuales es correcta',4),
 (4,'RL','Respuesta libre','Describir la solución razonada a la pregunta',12);
/*!40000 ALTER TABLE `tipo_pregunta` ENABLE KEYS */;




/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
