package es.upv.client;

import com.google.gwt.event.shared.SimpleEventBus;
import com.google.gwt.place.shared.PlaceController;
import com.google.web.bindery.event.shared.EventBus;
import com.smartgwt.client.types.Overflow;

import es.upv.client.ui.DummyPanel;
import es.upv.client.ui.DummyPanelView;
import es.upv.client.ui.Evaluaciones;
import es.upv.client.ui.InfoAcademica;
import es.upv.client.ui.InfoAcademicaView;
import es.upv.client.ui.LoginDialog;
import es.upv.client.ui.PanelAlumnoView;
import es.upv.client.ui.PanelAlumnos;
import es.upv.client.ui.PanelEvaluacionesView;
import es.upv.client.utils.TipoAcceso;

public class ClientFactoryImpl implements ClientFactory {
	private static final EventBus eventBus = new SimpleEventBus();
	private static final PlaceController placeController = new PlaceController(eventBus);

	private static PanelEvaluacionesView panelEvaluacionesView;
	private static PanelAlumnoView panelAlumnoView; 
	private static InfoAcademicaView panelInfoAcademicaView; 
	private static DummyPanelView dummyPanelView = new DummyPanel();
	private static LoginDialog loginDialog = new LoginDialog(TipoAcceso.ACCESO_ALUMNO);

	@Override
	public EventBus getEventBus() {
		return eventBus;
	}

	@Override
	public PlaceController getPlaceController() {
		return placeController;
	}

	@Override
	public PanelEvaluacionesView getPanelEvaluaciones() {
		
		if (panelEvaluacionesView == null) {
			Evaluaciones ev = new Evaluaciones ();
			
			ev.setWidth("95%");
			ev.setHeight("85%");
			ev.setOverflow(Overflow.VISIBLE);
			ev.setMinHeight(700);
			
			panelEvaluacionesView = ev;
		}
		
		return panelEvaluacionesView;
	}

	@Override
	public PanelAlumnoView getPanelAlumnos() {
		if (panelAlumnoView == null) {
			panelAlumnoView = new PanelAlumnos();
		}
		
		return panelAlumnoView;
	}

	@Override
	public DummyPanelView getDummyPanel() {
		return dummyPanelView;
	}

	@Override
	public InfoAcademicaView getPanelInfoAcademica() {
		if (panelInfoAcademicaView == null) {
			panelInfoAcademicaView = new InfoAcademica();
		}
		
		return panelInfoAcademicaView;
	}

	@Override
	public LoginDialog getLoginDialog() {
		return loginDialog;
	}

}
