package es.upv.client.mvp;

import com.google.gwt.activity.shared.Activity;
import com.google.gwt.activity.shared.ActivityMapper;
import com.google.gwt.place.shared.Place;

import es.upv.client.ClientFactory;
import es.upv.client.activity.AlumnoActivity;
import es.upv.client.activity.DummyActivity;
import es.upv.client.activity.EvaluacionesActivity;
import es.upv.client.activity.InfoAcademicaActivity;
import es.upv.client.place.DummyPanelPlace;
import es.upv.client.place.PanelAcademicaPlace;
import es.upv.client.place.PanelAlumnosPlace;
import es.upv.client.place.PanelEvaluacionesPlace;

public class AppActivityMapper implements ActivityMapper {

	private ClientFactory clientFactory;

	/**
	 * AppActivityMapper associates each Place with its corresponding
	 * {@link Activity}
	 * 
	 * @param clientFactory
	 *            Factory to be passed to activities
	 */
	public AppActivityMapper(ClientFactory clientFactory) {
		super();
		this.clientFactory = clientFactory;
	}

	/**
	 * Map each Place to its corresponding Activity. This would be a great use
	 * for GIN.
	 */
	@Override
	public Activity getActivity(Place place) {
		// This is begging for GIN
		if (place instanceof PanelAlumnosPlace)
			return new AlumnoActivity((PanelAlumnosPlace) place, clientFactory);
		else if (place instanceof PanelEvaluacionesPlace)
			return new EvaluacionesActivity((PanelEvaluacionesPlace) place, clientFactory);
		else if (place instanceof PanelAcademicaPlace)
			return new InfoAcademicaActivity((PanelAcademicaPlace) place, clientFactory);
		else if (place instanceof DummyPanelPlace)
			return new DummyActivity((DummyPanelPlace) place, clientFactory);

		return null;
	}

}
