package es.upv.client.ui;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.core.client.GWT;
import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.core.client.JsArray;
import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;
import com.google.gwt.json.client.JSONException;
import com.google.gwt.json.client.JSONObject;
import com.smartgwt.client.core.DataClass;
import com.smartgwt.client.data.DataSource;
import com.smartgwt.client.data.Record;
import com.smartgwt.client.types.Alignment;
import com.smartgwt.client.types.SelectionStyle;
import com.smartgwt.client.util.BooleanCallback;
import com.smartgwt.client.util.SC;
import com.smartgwt.client.widgets.EdgedCanvas;
import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.events.SubmitValuesEvent;
import com.smartgwt.client.widgets.form.events.SubmitValuesHandler;
import com.smartgwt.client.widgets.form.fields.ButtonItem;
import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.HiddenItem;
import com.smartgwt.client.widgets.form.fields.PasswordItem;
import com.smartgwt.client.widgets.form.fields.SpacerItem;
import com.smartgwt.client.widgets.form.fields.SubmitItem;
import com.smartgwt.client.widgets.form.fields.TextItem;
import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
import com.smartgwt.client.widgets.grid.ListGrid;
import com.smartgwt.client.widgets.grid.ListGridField;
import com.smartgwt.client.widgets.grid.events.RecordClickEvent;
import com.smartgwt.client.widgets.grid.events.RecordClickHandler;
import com.smartgwt.client.widgets.layout.HLayout;
import com.smartgwt.client.widgets.layout.VLayout;

import es.upv.client.ui.ds.AlumnoDatasource;
import es.upv.client.utils.JsonRequestAction;
import es.upv.client.utils.PersonaServiceUtils;
import es.upv.client.utils.TipoAcceso;
import es.upv.shared.model.PersonaOverlay;

public class AutoresComponent extends com.smartgwt.client.widgets.layout.VLayout {

	private ListGrid listadoAutores;
	private DataSource autoresDS;

	private DynamicForm autorForm;

	public AutoresComponent() {

		this.setAutoHeight();

		Label lblNewLabel_2 = new Label("<h3>Mantenimiento de autores</h3>");
		lblNewLabel_2.setAutoHeight();
		lblNewLabel_2.setAlign(Alignment.CENTER);
		addMember(lblNewLabel_2);

		listadoAutores = new ListGrid();
		listadoAutores.setHeight(175);
		listadoAutores.setShowFilterEditor(true);
		listadoAutores.setSelectionType(SelectionStyle.SINGLE);
		listadoAutores.setCanPickFields(false);
		listadoAutores.setCanGroupBy(false);
		// listadoAlumnos.setAutoFetchData(true);

		listadoAutores.setEmptyMessage("Sin resultados, utilizar los filtros para buscar");
		listadoAutores.setLoadingDataMessage("Obteniendo autores...");

		ListGridField fieldDNI = new ListGridField("dni", "DNI");
		fieldDNI.setWidth("10%");
		ListGridField fieldNombre = new ListGridField("primerNombre", "Nombre");
		fieldNombre.setWidth("*");
		ListGridField fieldApellido = new ListGridField("apellidoPaterno", "1er apellido");
		fieldApellido.setWidth("*");
		ListGridField fieldUsername = new ListGridField("usuario", "Usuario");
		fieldUsername.setWidth("20%");
		ListGridField fMail = new ListGridField("email", "Correo electrónico");
		fieldUsername.setWidth("20%");

		listadoAutores.setFields(new ListGridField[] { fieldDNI, fieldNombre, fieldApellido, fieldUsername, fMail });

		autoresDS = new AlumnoDatasource();
		listadoAutores.setDataSource(autoresDS);

		addMember(listadoAutores);

		EdgedCanvas edgedCanvas = new EdgedCanvas();
		edgedCanvas.setHeight(400);

		HLayout hLayout = new HLayout(5);
		hLayout.setPadding(10);
		hLayout.setHeight("50%");
		edgedCanvas.addChild(hLayout);
		hLayout.setMembersMargin(20);

		Label lblAutor = new Label("<strong>Información del autor</strong>");
		lblAutor.addStyleName("subtitulo");
		lblAutor.setHeight("24px");
		lblAutor.setBorder("");
		lblAutor.setAlign(Alignment.CENTER);
		addMember(lblAutor);

		autorForm = new DynamicForm();
		autorForm.setPadding(5);
		autorForm.setAutoHeight();
		autorForm.setNumCols(4);
		autorForm.setAutoWidth();

		TextItem textItem = new TextItem("direccion", "Direcci\u00F3n");
		textItem.setColSpan(2);
		textItem.setEndRow(true);
		textItem.setTitleColSpan(1);
		textItem.setShowTitle(true);
		textItem.setStartRow(true);
		TextItem textItem_1 = new TextItem("telefono", "Tel\u00E9fono");
		textItem_1.setStartRow(true);
		TextItem textItem_2 = new TextItem("apellidoMaterno", "Ap. 2");
		textItem_2.setTooltip("Apellido materno");
		textItem_2.setShowTitle(false);
		TextItem textNombre = new TextItem("primerNombre", "Nombre");
		textNombre.setStartRow(true);
		TextItem textItem_3 = new TextItem("segundoNombre", "");
		textItem_3.setTooltip("Segundo nombre");
		textItem_3.setShowTitle(false);
		TextItem textItem_4 = new TextItem("movil", "M\u00F3vil   ");
		textItem_4.setTooltip("Móvil");
		textItem_4.setShowTitle(false);
		SubmitItem submitItem_1 = new SubmitItem("save", "Guardar");
		submitItem_1.setTextAlign(Alignment.RIGHT);
		submitItem_1.setStartRow(true);
		submitItem_1.setEndRow(false);
		submitItem_1.setIcon("[SKIN]/actions/save.png");
		submitItem_1.setColSpan(4);
		submitItem_1.setAlign(Alignment.CENTER);
		
		ButtonItem buttonItem = new ButtonItem("newButtonItem_17", "Nuevo Autor");
		buttonItem.setColSpan(4);
		buttonItem.setAlign(Alignment.CENTER);
		
		buttonItem.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				listadoAutores.deselectAllRecords();
				autorForm.clearValues();
			}
		});
		buttonItem.setIcon("[SKIN]/actions/add.png");
		buttonItem.setStartRow(true);

		ButtonItem borrarButton = new ButtonItem("newButtonItem_17", "Borrar Autor");
		borrarButton.setColSpan(4);
		borrarButton.setAlign(Alignment.CENTER);
		borrarButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				final String id = autorForm.getValueAsString("id");

				SC.confirm(
						"¿Está seguro de eliminar el usuario? ",
						new BooleanCallback() {

							@Override
							public void execute(Boolean value) {
								if (value) {
									PersonaServiceUtils.borrarUsuario(TipoAcceso.ACCESO_AUTOR, id, new JsonRequestAction() {

										@Override
										public void successAction() {
											listadoAutores.removeSelectedData();
											autorForm.clearValues();
										}
									});
								}
							}

						});

			}
		});
		borrarButton.setIcon("[SKIN]/actions/remove.png");
		borrarButton.setStartRow(true);

		SpacerItem spacerItem = new SpacerItem();
		spacerItem.setStartRow(false);
		TextItem itemDNI = new TextItem("dni", "DNI");
		itemDNI.setHint("Nuevo autor");
		itemDNI.setShowHintInField(true);

		TextItem itemMail = new TextItem("email", "e-mail");
		itemMail.setColSpan(4);
		itemMail.setWidth("*");
		
		TextItem itemDespacho = new TextItem("despacho", "Despacho");
		itemDespacho.setColSpan(4);
		itemDespacho.setWidth("*");

		autorForm.setFields(new FormItem[] {
				// id
				new HiddenItem("id"),
				// dni del alumno
				itemDNI,
				// primer nombre del alumno, new TextItem("nombre",
				// "Nombre"),
				textNombre,
				// segundo nombre del alumno
				textItem_3,
				// apellidos
				new TextItem("apellidoPaterno", "Apellidos"), textItem_2,
				// dirección
				textItem,
				// telefono
				textItem_1,
				// movil
				textItem_4,
				// usuario
				new TextItem("usuario", "Usuario"), new SpacerItem(),
				// clave
				new PasswordItem("clave", "Contraseña"), new SpacerItem(),
				// email
				itemMail,
				// despacho
				itemDespacho,
				// concurrencia
				new HiddenItem("version"), spacerItem, submitItem_1, buttonItem, borrarButton });
		
		// dynamicForm.setCanSubmit(true);
		autorForm.setIsGroup(true);
		autorForm.setGroupTitle("Datos alumno");
		autorForm.addSubmitValuesHandler(new SubmitValuesHandler() {

			@Override
			public void onSubmitValues(SubmitValuesEvent event) {

				if (autorForm.validate()) {

					JavaScriptObject datosAlumno = event.getValues();
					Log.debug("Alumno a guardar " + new JSONObject(datosAlumno).toString());

					if (autorForm.getValue("id") != null) {

						Record nuevoAlumno = new Record(datosAlumno);
						PersonaServiceUtils.guardarUsuario(TipoAcceso.ACCESO_AUTOR, nuevoAlumno, new JsonRequestAction() {
							@Override
							public void successAction(Record datosGuardados) {

								autoresDS.updateData(datosGuardados);
								listadoAutores.selectRecord(datosGuardados);
								autorForm.setValue("version", datosGuardados.getAttributeAsInt("version"));
								autorForm.setValue("clave", datosGuardados.getAttributeAsString("clave"));

							}
						});

					} else {
						// es nuevo
						// guardar datos
						Record nuevoAlumno = new Record(datosAlumno);
						PersonaServiceUtils.guardarUsuario(TipoAcceso.ACCESO_AUTOR, nuevoAlumno, new JsonRequestAction() {
							@Override
							public void successAction(Record datosGuardados) {

								listadoAutores.addData(datosGuardados);
								listadoAutores.selectRecord(datosGuardados);
								
								autorForm.setValue("id", datosGuardados.getAttributeAsInt("id"));
								autorForm.setValue("version", datosGuardados.getAttributeAsInt("version"));
								autorForm.setValue("clave", datosGuardados.getAttributeAsString("clave"));
								

							}
						});

					}

				}
			}
		});
		autorForm.setDataSource(autoresDS);
		hLayout.addMember(autorForm);

		VLayout layout = new VLayout();
		layout.setPadding(4);
		layout.setHeight(200);

		listadoAutores.addRecordClickHandler(new RecordClickHandler() {

			@Override
			public void onRecordClick(RecordClickEvent event) {
				Record seleccionado = listadoAutores.getSelectedRecord();

				autorForm.editRecord(seleccionado);
			}

		});

		addMember(edgedCanvas);

		// initWidget(this);
	}


	public void actualizarAutores() {

		// limpiar la lista
		limpiaListado();

		Date now = new Date();
		String url = GWT.getHostPageBaseURL() + "services/api/autores/list.json?now=" + now.getTime();

		RequestBuilder builder = new RequestBuilder(RequestBuilder.GET, url);
		builder.setHeader("Pragma", "no-cache");

		try {
			builder.sendRequest(null, new RequestCallback() {
				public void onError(Request request, Throwable exception) {

				}

				public void onResponseReceived(Request request, Response response) {
					if (200 == response.getStatusCode()) {
						try {
							// parse the response text into JSON
							JsArray<PersonaOverlay> data = PersonaOverlay.arrayFromJson(response.getText());

							/*
							 * JSONValue jsonValue = JSONParser
							 * .parseStrict(response.getText()); JSONArray
							 * jsonArray = jsonValue.isArray(); // for
							 * (jsonArray.get)
							 */
							Log.debug(response.getText());

							List<PersonaOverlay> alumnos = new ArrayList<PersonaOverlay>();
							DataClass[] lista = new DataClass[data.length()];
							for (int i = 0; i < data.length(); i++) {
								alumnos.add(data.get(i));
								lista[i] = new DataClass(data.get(i));

								Record r = new Record(data.get(i));

								/*
								 * Log.debug("Asignatura: " +
								 * Arrays.toString(r.getAttributes()));
								 * Log.debug("Asignatura: " + String.valueOf(r
								 * .getAttribute("cursoNombre")));
								 */
								// action for one record
								listadoAutores.addData(r);
							}

							// listadoAlumnos.fetchData();

						} catch (JSONException e) {
						}
					} else {

					}
				}
			});
		} catch (RequestException e) {

		}
	}

	public void limpiaListado() {
		autoresDS.setTestData(new DataClass[] {});
		this.listadoAutores.setData(new Record[] {});
	}

}
