package es.upv.client.ui;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.core.client.GWT;
import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;
import com.google.gwt.json.client.JSONNumber;
import com.google.gwt.json.client.JSONObject;
import com.google.gwt.json.client.JSONString;
import com.google.gwt.user.client.Window;
import com.smartgwt.client.data.Record;
import com.smartgwt.client.types.Alignment;
import com.smartgwt.client.types.SelectionStyle;
import com.smartgwt.client.types.ValidatorType;
import com.smartgwt.client.util.JSOHelper;
import com.smartgwt.client.util.SC;
import com.smartgwt.client.widgets.Button;
import com.smartgwt.client.widgets.Canvas;
import com.smartgwt.client.widgets.ImgButton;
import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.events.ClickEvent;
import com.smartgwt.client.widgets.events.ClickHandler;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.events.SubmitValuesEvent;
import com.smartgwt.client.widgets.form.events.SubmitValuesHandler;
import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.HiddenItem;
import com.smartgwt.client.widgets.form.fields.SubmitItem;
import com.smartgwt.client.widgets.form.fields.TextAreaItem;
import com.smartgwt.client.widgets.form.fields.TextItem;
import com.smartgwt.client.widgets.form.validator.Validator;
import com.smartgwt.client.widgets.grid.ListGrid;
import com.smartgwt.client.widgets.grid.ListGridField;
import com.smartgwt.client.widgets.grid.ListGridRecord;
import com.smartgwt.client.widgets.grid.events.SelectionChangedHandler;
import com.smartgwt.client.widgets.grid.events.SelectionEvent;
import com.smartgwt.client.widgets.layout.HLayout;

import es.upv.client.ui.events.CentrosChangedEvent;
import es.upv.shared.model.CentroOverlay;

public class CentrosComponent extends com.smartgwt.client.widgets.layout.VLayout {

	private ListGrid listGrid_centros;
	private DynamicForm dynamicForm;

	public AsignaturasComponent asignaturasComponent;

	private HLayout rollOverCanvas;
	private ListGridRecord rollOverRecord;

	public CentrosComponent() {

		setAutoHeight();

		Label lblNewLabel_2 = new Label("<h3>Mantenimiento de centros</h3>");
		lblNewLabel_2.setAutoHeight();
		lblNewLabel_2.setAlign(Alignment.CENTER);
		this.addMember(lblNewLabel_2);

		listGrid_centros = crearListadoGrid();
		this.addMember(listGrid_centros);

		HLayout buttonLayout = new HLayout();
		buttonLayout.setMargin(5);
		buttonLayout.setDefaultLayoutAlign(Alignment.RIGHT);
		Button newButton = new Button("Nuevo centro");
		newButton.setIcon("[SKIN]/actions/add.png");

		newButton.addClickHandler(new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {
				dynamicForm.setGroupTitle("Información del nuevo centro");
				dynamicForm.reset();
				dynamicForm.resetValues();

				listGrid_centros.deselectAllRecords();
			}
		});

		buttonLayout.setAlign(Alignment.RIGHT);
		buttonLayout.addMember(newButton);
		addMember(buttonLayout);

		dynamicForm = new DynamicForm();
		dynamicForm.setPadding(10);
		dynamicForm.setIsGroup(true);
		dynamicForm.setGroupTitle("Seleccionar centro o crear un nuevo....");
		dynamicForm.setWidth100();
		dynamicForm.addSubmitValuesHandler(new SubmitValuesHandler() {
			public void onSubmitValues(SubmitValuesEvent event) {

				if (!dynamicForm.validate())
					return;

				// obtener los valores del form y enviarlo a guardar
				// test guardar
				String urlsave = GWT.getHostPageBaseURL() + "services/api/centros/save.json";
				RequestBuilder builder2 = new RequestBuilder(RequestBuilder.POST, urlsave);
				builder2.setHeader("Content-Type", "application/json");
				builder2.setHeader("Pragma", "no-cache");

				try {
					JSONObject nuevoCentro = new JSONObject();

					final Object id = dynamicForm.getValue("txt_id_centro");
					if (id != null) {
						// editando un valor
						nuevoCentro.put("id",
								new JSONNumber(Double.valueOf(dynamicForm.getValueAsString("txt_id_centro"))));
					}

					// Generar un objeto json con las propiedades del formulario
					nuevoCentro.put("nombre", new JSONString(dynamicForm.getValueAsString("txt_nombre_centro")));
					nuevoCentro.put("siglas", new JSONString(dynamicForm.getValueAsString("txt_siglas_centro")));
					nuevoCentro.put("descripcion",
							new JSONString(dynamicForm.getValueAsString("txt_descripcion_centro")));

					if (dynamicForm.getValueAsString("txt_version_centro") != null)
						nuevoCentro.put("version",
								new JSONNumber(Double.valueOf(dynamicForm.getValueAsString("txt_version_centro"))));

					builder2.sendRequest(nuevoCentro.toString(), new RequestCallback() {

						@Override
						public void onResponseReceived(Request request, Response response) {
							CentroOverlay centroGuardado = CentroOverlay.fromJson(response.getText());

							CentroOverlay centroGuardado2 = (CentroOverlay) JSOHelper.eval(response.getText());
							// Window.alert("Guardado! : " +
							// centroGuardado2.toString());

							// a�adirlo a la lista de listGrid si el id
							// es nulo
							if (id == null) {
								Record r = new Record(centroGuardado);

								listGrid_centros.addData(r);
								listGrid_centros.selectRecord(r, true);

							} else {
								// Actualizar!
								Record seleccionado = listGrid_centros.getSelectedRecord();
								int selectIdx = listGrid_centros.getRecordIndex(seleccionado);
								// seleccionado.setJsObj(centroGuardado);

								seleccionado.setAttribute("nombre", centroGuardado2.getNombre());
								seleccionado.setAttribute("siglas", centroGuardado2.getSiglas());
								seleccionado.setAttribute("descripcion", centroGuardado2.getDescripcion());
								seleccionado.setAttribute("version", centroGuardado2.getVersion());

								dynamicForm.setValue("txt_version_centro", centroGuardado2.getVersion());
								dynamicForm.setValue("txt_id_centro", centroGuardado2.getId());

								listGrid_centros.refreshRow(selectIdx);
								Log.debug("*** indice update : " + selectIdx);

								// listGrid_2.updateData(seleccionado);
							}

							Root.EVENT_BUS.fireEvent(new CentrosChangedEvent());
						}

						@Override
						public void onError(Request request, Throwable exception) {
							Window.alert("Error al guardar");

						}
					});
				} catch (RequestException e) {
					// lblNewLabel_4.setContents("Couldn't retrieve JSON");
				}

			}
		});

		SubmitItem submitItem = new SubmitItem();
		submitItem.setTitle("Guardar");
		submitItem.setIcon("[SKIN]/actions/save.png");

		// validador de campos requeridos
		Validator requiredVal = new Validator();
		requiredVal.setType(ValidatorType.REQUIRED);

		HiddenItem hiddenItem = new HiddenItem();
		hiddenItem.setName("txt_id_centro");
		HiddenItem versionItem = new HiddenItem("txt_version_centro");
		TextItem fNombre = new TextItem("txt_nombre_centro", "Nombre");
		fNombre.setShowHintInField(true);
		fNombre.setHint("Nombre del nuevo centro");
		fNombre.setValidators(requiredVal);

		TextAreaItem fDesc = new TextAreaItem("txt_descripcion_centro", "Descripci\u00F3n");
		fDesc.setValidators(requiredVal);

		fDesc.setWidth(400);
		fNombre.setWidth(400);
		dynamicForm.setFields(new FormItem[] { hiddenItem, versionItem, fNombre,
				new TextItem("txt_siglas_centro", "Siglas"), fDesc, submitItem });
		this.addMember(dynamicForm);

		// initWidget(this);
	}

	private ListGrid crearListadoGrid() {
		
		ListGrid listGrid = new ListGrid() {
			@Override
			protected Canvas getRollOverCanvas(final Integer rowNum, Integer colNum) {
				rollOverRecord = this.getRecord(rowNum);

				if (rollOverCanvas == null) {
					rollOverCanvas = new HLayout(3);
					rollOverCanvas.setSnapTo("TR");
					rollOverCanvas.setWidth(10);
					rollOverCanvas.setHeight(22);

					ImgButton editImg = new ImgButton();
					editImg.setShowDown(false);
					editImg.setShowRollOver(false);
					editImg.setLayoutAlign(Alignment.CENTER);
					editImg.setSrc("[SKIN]/actions/remove.png");
					editImg.setPrompt("Eliminar centro");
					editImg.setHeight(16);
					editImg.setWidth(16);
					editImg.addClickHandler(new ClickHandler() {
						public void onClick(ClickEvent event) {
							String centroid = rollOverRecord.getAttribute("id");

							final ListGridRecord filaBorrar;
							for (ListGridRecord r : listGrid_centros.getRecords()) {
								if (r.getAttribute("id").equals(centroid)) {

									filaBorrar = r;

									// obtener los valores del form y enviarlo a
									// guardar
									// test guardar
									String urlremove = GWT.getHostPageBaseURL() + "services/api/centros/delete/"
											+ r.getAttribute("id") + ".json";
									RequestBuilder builder2 = new RequestBuilder(RequestBuilder.POST, urlremove);
									builder2.setHeader("Content-Type", "application/json");
									builder2.setHeader("Pragma", "no-cache");

									try {
										builder2.sendRequest(null, new RequestCallback() {

											@Override
											public void onResponseReceived(Request request, Response response) {

												// ejecutar la accion de
												// correcto
												if (listGrid_centros.isSelected(filaBorrar))
													dynamicForm.clearValues();
												
												listGrid_centros.removeData(filaBorrar);
											}

											@Override
											public void onError(Request request, Throwable exception) {
												SC.warn("Error al elimnar el centro");
											}
										});
									} catch (RequestException e) {
										SC.warn("Error al elimnar el centro");
									}

									break;
								}
							}

							Log.debug("eliminando " + rowNum);
							Log.debug("eliminando recorde con id " + centroid);

						}
					});

					rollOverCanvas.addMember(editImg);
				}
				return rollOverCanvas;

			}
		};
		
		listGrid.setShowRollOverCanvas(true);
		listGrid.setAlternateRecordStyles(true);

		listGrid.setHeight(200);
		listGrid.setSelectionType(SelectionStyle.SINGLE);
		listGrid.setCanPickFields(false);
		listGrid.setCanGroupBy(false);
		listGrid.addSelectionChangedHandler(new SelectionChangedHandler() {
			public void onSelectionChanged(SelectionEvent event) {
				if (event.getState()) { // nuevo seleccionado

					dynamicForm.setGroupTitle("Información del centro");

					// Poner los valores en el text
					Record r = event.getRecord();
					dynamicForm.setValue("txt_id_centro", r.getAttribute("id"));
					dynamicForm.setValue("txt_siglas_centro", r.getAttribute("siglas"));
					dynamicForm.setValue("txt_nombre_centro", r.getAttribute("nombre"));
					dynamicForm.setValue("txt_descripcion_centro", r.getAttribute("descripcion"));
					dynamicForm.setValue("txt_version_centro", r.getAttribute("version"));

				} else {
					// Deseleccionando :
					// FIXME : Si est� editando un nuevo valor.... avisar!
				}
			}
		});

		ListGridField listGridField0 = new ListGridField("siglas", "Siglas");
		listGridField0.setWidth("10%");
		ListGridField listGridField = new ListGridField("nombre", "Nombre Centro");
		listGridField0.setWidth("20%");
		ListGridField listGridField_1 = new ListGridField("descripcion", "Descripci\u00F3n");
		listGridField0.setWidth("*");
		ListGridField listGridField_2 = new ListGridField("id", "Id");
		listGridField_2.setWidth("5%");
		ListGridField listGridField_version = new ListGridField("version", "version");
		listGridField_version.setHidden(false);

		listGrid.setFields(new ListGridField[] { listGridField_2, listGridField, listGridField0, listGridField_1,
				listGridField_version });
		
		return listGrid;
	}

	public void addCentro(Record r) {
		this.listGrid_centros.addData(r);
	}

	public void limpiaCentros() {
		this.listGrid_centros.setData(new Record[] {});
	}

}
