package es.upv.client.ui;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.KeyPressEvent;
import com.google.gwt.event.dom.client.KeyPressHandler;
import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;
import com.google.gwt.http.client.URL;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.FormPanel;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.PasswordTextBox;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.smartgwt.client.data.Record;

import es.upv.client.place.DummyPanelPlace;
import es.upv.client.ui.PanelAlumnoView.Presenter;
import es.upv.client.ui.events.UsuarioValidadoEvent;
import es.upv.client.utils.JsonRequestAction;
import es.upv.client.utils.PersonaServiceUtils;
import es.upv.client.utils.TipoAcceso;

public class LoginDialog extends DialogBox {
	private Presenter listener;

	private TipoAcceso tipoAcceso;
	
	public TextBox usuField;
	public PasswordTextBox passField;
	
	private Image usuarioAlert;
	private Image claveAlert;

	public LoginDialog(TipoAcceso tipoAcceso) {
		this.tipoAcceso = tipoAcceso;
		
		setModal(true);
		setTitle("");
		setGlassEnabled(true);
		setAnimationEnabled(true);
		setAutoHideOnHistoryEventsEnabled(false);
		
		// Add the button and list to a panel
		VerticalPanel vPanel = new VerticalPanel();
		vPanel.setSpacing(8);
		vPanel.getElement().getStyle().setPadding(10, Unit.PX);

		Image image = new Image();
		image.setTitle("Debe introducir un usuario");
		image.setUrl("evaltics/sc/skins/Enterprise/images/Dialog/ask.png");
		image.setSize("32px", "32px");
		vPanel.add(image);
		vPanel.setCellHorizontalAlignment(image, HasHorizontalAlignment.ALIGN_CENTER);

		Label lblNewLabel = new Label();
		lblNewLabel.setText("Introduzca nombre de usuario y clave para continuar");
		lblNewLabel.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_CENTER);
		lblNewLabel.setStyleName("defaultLabel");
		lblNewLabel.setSize("100%", "57px");

		vPanel.add(lblNewLabel);

		FormPanel loginForm = new FormPanel();
		vPanel.add(loginForm);

		VerticalPanel verticalPanel = new VerticalPanel();
		loginForm.setWidget(verticalPanel);
		verticalPanel.setSize("334px", "100%");

		Label lblNewLabel_2 = new Label("Usuario");
		verticalPanel.add(lblNewLabel_2);

		HorizontalPanel horizontalPanel = new HorizontalPanel();
		verticalPanel.add(horizontalPanel);
		horizontalPanel.setWidth("100%");

		usuField = new TextBox();
		horizontalPanel.add(usuField);
		usuField.setWidth("100%");
		
		usuField.addKeyUpHandler(new KeyUpHandler() {
			
			@Override
			public void onKeyUp(KeyUpEvent event) {
				if (! usuField.getValue().trim().isEmpty() )
					usuarioAlert.setVisible(false);
			}
		});

		usuarioAlert = new Image("evaltics/sc/skins/Enterprise/images/actions/exclamation.png");
		usuarioAlert.setTitle("Usuario es obligatorio");
		usuarioAlert.setAltText("Requerido");
		usuarioAlert.setVisible(false);
		horizontalPanel.add(usuarioAlert);
		horizontalPanel.setCellHorizontalAlignment(usuarioAlert, HasHorizontalAlignment.ALIGN_RIGHT);
		horizontalPanel.setCellVerticalAlignment(usuarioAlert, HasVerticalAlignment.ALIGN_MIDDLE);

		Label lblNewLabel_3 = new Label("Clave");
		verticalPanel.add(lblNewLabel_3);
		lblNewLabel_3.getElement().getStyle().setMarginTop(10, Unit.PX);

		HorizontalPanel horizontalPanel_1 = new HorizontalPanel();
		verticalPanel.add(horizontalPanel_1);
		horizontalPanel_1.setWidth("100%");

		passField = new PasswordTextBox();
		horizontalPanel_1.add(passField);
		passField.setWidth("100%");
		
		passField.addKeyUpHandler(new KeyUpHandler() {
			
			@Override
			public void onKeyUp(KeyUpEvent event) {
				if (! passField.getValue().trim().isEmpty() )
					claveAlert.setVisible(false);
			}
		});

		claveAlert = new Image("evaltics/sc/skins/Enterprise/images/actions/exclamation.png");
		claveAlert.setTitle("Clave es obligatorio");
		claveAlert.setAltText("Requerido");
		claveAlert.setVisible(false);
		horizontalPanel_1.add(claveAlert);
		horizontalPanel_1.setCellHorizontalAlignment(claveAlert, HasHorizontalAlignment.ALIGN_RIGHT);
		horizontalPanel_1.setCellVerticalAlignment(claveAlert, HasVerticalAlignment.ALIGN_MIDDLE);

		final Button btnGo = new Button("Entrar!");
		Button btnCancel = new Button("Cancelar");

		vPanel.add(btnGo);
		vPanel.setCellHorizontalAlignment(btnGo, HasHorizontalAlignment.ALIGN_RIGHT);
		vPanel.add(btnCancel);
		vPanel.setCellHorizontalAlignment(btnCancel, HasHorizontalAlignment.ALIGN_RIGHT);

		btnGo.addClickHandler(new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {

				boolean validate = true;
				if (usuField.getValue() == null || usuField.getValue().trim().isEmpty()) {
					usuarioAlert.setVisible(true);
					validate = false;
				}
				
				if (passField.getValue() == null || passField.getValue().trim().isEmpty()) {
					claveAlert.setVisible(true);
					validate = false;
				}
				
				Log.debug("valida usuario");
				if (validate) 
					ejecutarAccionLogin();
			}
		});
		
		/* al pulsar intro, se ejecuta el login */
		usuField.addKeyPressHandler(new KeyPressHandler() {
			
			@Override
			public void onKeyPress(KeyPressEvent event) {
				if (event.getCharCode() == 13) 
					btnGo.click();
			}
		});
		
		passField.addKeyPressHandler(new KeyPressHandler() {
			
			@Override
			public void onKeyPress(KeyPressEvent event) {
				if (event.getCharCode() == 13) 
					btnGo.click();
			}
		});

		btnCancel.addClickHandler(new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {
				
				hide();
				listener.goTo(new DummyPanelPlace());
				// Window.Location.assign(GWT.getHostPageBaseURL() + "Evaltics.html#");

			}
		});


		getElement().getStyle().setZIndex(300001);
		add(vPanel);
	}

	protected void ejecutarAccionLogin() {

		RequestBuilder request = new RequestBuilder(RequestBuilder.POST, GWT.getHostPageBaseURL() + "j_security_check");
		request.setHeader("Content-Type", "application/x-www-form-urlencoded");

		try {
			request.sendRequest(
					"j_username=" + URL.encode(usuField.getValue()) + "&j_password=" + URL.encode(passField.getValue()),
					new RequestCallback() {

						@Override
						public void onResponseReceived(Request request, Response response) {
							Log.debug("Respuesta j_security_check: " + response.getStatusCode());
							Log.debug(response.getText());

							// FIXME : obtener el resultado correcto de
							// alguna manera
							if (response.getText() != null && (response.getText().contains("j_security_check") || 
									response.getText().contains("EvalticsForbiddenException"))) {
								// error en la validacion

								Root.EVENT_BUS.fireEvent(new UsuarioValidadoEvent(false, null));
							} else {
								
								Log.debug("usuario correcto");

								PersonaServiceUtils.validarUsuario(tipoAcceso, usuField.getValue(), passField.getValue(),
										new JsonRequestAction() {
											@Override
											public void successAction(Record datosGuardados) {

												// lanzar evento
												// logeado!!
												Root.EVENT_BUS
														.fireEvent(new UsuarioValidadoEvent(true, datosGuardados));
											}

											@Override
											public void failureAction() {
												// probar un profesor
												
												PersonaServiceUtils.validarUsuario(TipoAcceso.ACCESO_AUTOR, usuField.getValue(), passField.getValue(),
														new JsonRequestAction() {
															@Override
															public void successAction(Record datosGuardados) {

																// lanzar evento
																// logeado!!
																Root.EVENT_BUS
																		.fireEvent(new UsuarioValidadoEvent(true, datosGuardados));
															}

															@Override
															public void failureAction() {
																Root.EVENT_BUS.fireEvent(new UsuarioValidadoEvent(false, null));
															}
														});
												
											}
										});

							}

						}

						@Override
						public void onError(Request request, Throwable exception) {
							com.google.gwt.user.client.Window.alert("Respuesta : " + exception.getLocalizedMessage());

							Root.EVENT_BUS.fireEvent(new UsuarioValidadoEvent(false, null));

						}
					});
		} catch (RequestException e) {
			com.google.gwt.user.client.Window.alert("Error en j_security_check");
		}

	}

	public void setListener(Presenter listener) {
		this.listener = listener;
	}

}
