package es.upv.client.ui;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.core.client.GWT;
import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.core.client.JsArray;
import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;
import com.google.gwt.json.client.JSONException;
import com.google.gwt.json.client.JSONObject;
import com.smartgwt.client.core.DataClass;
import com.smartgwt.client.data.DataSource;
import com.smartgwt.client.data.Record;
import com.smartgwt.client.types.Alignment;
import com.smartgwt.client.types.GroupStartOpen;
import com.smartgwt.client.types.SelectionStyle;
import com.smartgwt.client.types.SortDirection;
import com.smartgwt.client.util.BooleanCallback;
import com.smartgwt.client.util.SC;
import com.smartgwt.client.widgets.Canvas;
import com.smartgwt.client.widgets.EdgedCanvas;
import com.smartgwt.client.widgets.ImgButton;
import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.events.SubmitValuesEvent;
import com.smartgwt.client.widgets.form.events.SubmitValuesHandler;
import com.smartgwt.client.widgets.form.fields.ButtonItem;
import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.HiddenItem;
import com.smartgwt.client.widgets.form.fields.PasswordItem;
import com.smartgwt.client.widgets.form.fields.SpacerItem;
import com.smartgwt.client.widgets.form.fields.SubmitItem;
import com.smartgwt.client.widgets.form.fields.TextItem;
import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
import com.smartgwt.client.widgets.grid.ListGrid;
import com.smartgwt.client.widgets.grid.ListGridField;
import com.smartgwt.client.widgets.grid.ListGridRecord;
import com.smartgwt.client.widgets.grid.events.RecordClickEvent;
import com.smartgwt.client.widgets.grid.events.RecordClickHandler;
import com.smartgwt.client.widgets.grid.events.SelectionChangedHandler;
import com.smartgwt.client.widgets.grid.events.SelectionEvent;
import com.smartgwt.client.widgets.layout.HLayout;
import com.smartgwt.client.widgets.layout.VLayout;

import es.upv.client.ui.ds.AlumnoDatasource;
import es.upv.client.ui.ds.AsignaturaDatasource;
import es.upv.client.utils.JsonRequestAction;
import es.upv.client.utils.PersonaServiceUtils;
import es.upv.client.utils.TipoAcceso;
import es.upv.shared.model.AsignaturaOverlay;
import es.upv.shared.model.PersonaOverlay;

public class MatriculasComponent extends com.smartgwt.client.widgets.layout.VLayout {

	private ListGrid listadoAlumnos;
	private ListGrid listadoAsignaturas;
	private DataSource alumnoDS;
	private AsignaturaDatasource asignaturasDataSource;

	private HLayout rollOverCanvas;
	private ListGridRecord rollOverRecord;
	private ImgButton editImg;
	private DynamicForm alumnoForm;

	public MatriculasComponent(AsignaturaDatasource asignaturasDataSource) {

		this.asignaturasDataSource = asignaturasDataSource;
		this.setAutoHeight();

		Label lblNewLabel_2 = new Label("<h3>Mantenimiento de alumnos y matrículas</h3>");
		lblNewLabel_2.setAutoHeight();
		lblNewLabel_2.setAlign(Alignment.CENTER);
		addMember(lblNewLabel_2);

		listadoAlumnos = new ListGrid();
		listadoAlumnos.setHeight(175);
		listadoAlumnos.setShowFilterEditor(true);
		listadoAlumnos.setSelectionType(SelectionStyle.SINGLE);
		listadoAlumnos.setCanPickFields(false);
		listadoAlumnos.setCanGroupBy(false);
		// listadoAlumnos.setAutoFetchData(true);

		listadoAlumnos.setEmptyMessage("Sin resultados, utilizar los filtros para buscar");
		listadoAlumnos.setLoadingDataMessage("Obteniendo alumnos...");

		ListGridField fieldDNI = new ListGridField("dni", "DNI");
		fieldDNI.setWidth("10%");
		ListGridField fieldNombre = new ListGridField("primerNombre", "Nombre");
		fieldNombre.setWidth("*");
		ListGridField fieldApellido = new ListGridField("apellidoPaterno", "1er apellido");
		fieldApellido.setWidth("*");
		ListGridField fieldUsername = new ListGridField("usuario", "Usuario");
		fieldUsername.setWidth("20%");
		ListGridField fMail = new ListGridField("email", "Correo electrónico");
		fieldUsername.setWidth("20%");

		listadoAlumnos.setFields(new ListGridField[] { fieldDNI, fieldNombre, fieldApellido, fieldUsername, fMail });

		alumnoDS = new AlumnoDatasource();
		listadoAlumnos.setDataSource(alumnoDS);

		addMember(listadoAlumnos);

		EdgedCanvas edgedCanvas = new EdgedCanvas();
		edgedCanvas.setHeight(400);

		HLayout hLayout = new HLayout(5);
		hLayout.setPadding(10);
		hLayout.setHeight("50%");
		edgedCanvas.addChild(hLayout);
		hLayout.setMembersMargin(20);

		Label lblAlumno = new Label("<strong>Información del alumno</strong>");
		lblAlumno.addStyleName("subtitulo");
		lblAlumno.setHeight("24px");
		lblAlumno.setBorder("");
		lblAlumno.setAlign(Alignment.CENTER);
		addMember(lblAlumno);

		alumnoForm = new DynamicForm();
		alumnoForm.setPadding(5);
		alumnoForm.setAutoHeight();
		alumnoForm.setNumCols(4);
		alumnoForm.setAutoWidth();

		TextItem textItem = new TextItem("direccion", "Direcci\u00F3n");
		textItem.setColSpan(2);
		textItem.setEndRow(true);
		textItem.setTitleColSpan(1);
		textItem.setShowTitle(true);
		textItem.setStartRow(true);
		TextItem textItem_1 = new TextItem("telefono", "Tel\u00E9fono");
		textItem_1.setStartRow(true);
		TextItem textItem_2 = new TextItem("apellidoMaterno", "Ap. 2");
		textItem_2.setTooltip("Apellido materno");
		textItem_2.setShowTitle(false);
		TextItem textNombre = new TextItem("primerNombre", "Nombre");
		textNombre.setStartRow(true);
		TextItem textItem_3 = new TextItem("segundoNombre", "");
		textItem_3.setTooltip("Segundo nombre");
		textItem_3.setShowTitle(false);
		TextItem textItem_4 = new TextItem("movil", "M\u00F3vil   ");
		textItem_4.setTooltip("Móvil");
		textItem_4.setShowTitle(false);
		SubmitItem submitItem_1 = new SubmitItem("save", "Guardar");
		submitItem_1.setTextAlign(Alignment.RIGHT);
		submitItem_1.setStartRow(true);
		submitItem_1.setEndRow(false);
		submitItem_1.setIcon("[SKIN]/actions/save.png");
		submitItem_1.setColSpan(4);
		submitItem_1.setAlign(Alignment.CENTER);
		
		ButtonItem buttonItem = new ButtonItem("newButtonItem_17", "Nuevo Alumno");
		buttonItem.setColSpan(4);
		buttonItem.setAlign(Alignment.CENTER);
		
		buttonItem.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				listadoAlumnos.deselectAllRecords();
				alumnoForm.clearValues();
			}
		});
		buttonItem.setIcon("[SKIN]/actions/add.png");
		buttonItem.setStartRow(true);

		ButtonItem borrarButton = new ButtonItem("newButtonItem_17", "Borrar Alumno");
		borrarButton.setColSpan(4);
		borrarButton.setAlign(Alignment.CENTER);
		borrarButton.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				final String id = alumnoForm.getValueAsString("id");

				SC.confirm(
						"¿Está seguro de eliminar el usuario? Se perderán todas sus matrículas y las evaluaciones realizadas",
						new BooleanCallback() {

							@Override
							public void execute(Boolean value) {
								if (value) {
									PersonaServiceUtils.borrarUsuario(TipoAcceso.ACCESO_ALUMNO, id, new JsonRequestAction() {

										@Override
										public void successAction() {
											listadoAlumnos.removeSelectedData();
											alumnoForm.clearValues();
										}
									});
								}
							}

						});

			}
		});
		borrarButton.setIcon("[SKIN]/actions/remove.png");
		borrarButton.setStartRow(true);

		SpacerItem spacerItem = new SpacerItem();
		spacerItem.setStartRow(false);
		TextItem itemDNI = new TextItem("dni", "DNI");
		itemDNI.setHint("Nuevo alumno");
		itemDNI.setShowHintInField(true);

		TextItem itemMail = new TextItem("email", "e-mail");
		itemMail.setColSpan(4);
		itemMail.setWidth("*");

		alumnoForm.setFields(new FormItem[] {
				// id
				new HiddenItem("id"),
				// dni del alumno
				itemDNI,
				// primer nombre del alumno, new TextItem("nombre",
				// "Nombre"),
				textNombre,
				// segundo nombre del alumno
				textItem_3,
				// apellidos
				new TextItem("apellidoPaterno", "Apellidos"), textItem_2,
				// dirección
				textItem,
				// telefono
				textItem_1,
				// movil
				textItem_4,
				// usuario
				new TextItem("usuario", "Usuario"), new SpacerItem(),
				// clave
				new PasswordItem("clave", "Contraseña"), new SpacerItem(),
				// email
				itemMail,
				// concurrencia
				new HiddenItem("version"), spacerItem, submitItem_1, buttonItem, borrarButton });
		
		// dynamicForm.setCanSubmit(true);
		alumnoForm.setIsGroup(true);
		alumnoForm.setGroupTitle("Datos alumno");
		alumnoForm.addSubmitValuesHandler(new SubmitValuesHandler() {

			@Override
			public void onSubmitValues(SubmitValuesEvent event) {

				if (alumnoForm.validate()) {

					JavaScriptObject datosAlumno = event.getValues();
					Log.debug("Alumno a guardar " + new JSONObject(datosAlumno).toString());

					if (alumnoForm.getValue("id") != null) {

						Record nuevoAlumno = new Record(datosAlumno);
						PersonaServiceUtils.guardarUsuario(TipoAcceso.ACCESO_ALUMNO, nuevoAlumno, new JsonRequestAction() {
							@Override
							public void successAction(Record datosGuardados) {

								alumnoDS.updateData(datosGuardados);
								listadoAlumnos.selectRecord(datosGuardados);
								alumnoForm.setValue("version", datosGuardados.getAttributeAsInt("version"));
								alumnoForm.setValue("clave", datosGuardados.getAttributeAsString("clave"));

							}
						});

					} else {
						// es nuevo
						// guardar datos
						Record nuevoAlumno = new Record(datosAlumno);
						PersonaServiceUtils.guardarUsuario(TipoAcceso.ACCESO_ALUMNO, nuevoAlumno, new JsonRequestAction() {
							@Override
							public void successAction(Record datosGuardados) {

								listadoAlumnos.addData(datosGuardados);
								listadoAlumnos.selectRecord(datosGuardados);
								
								alumnoForm.setValue("id", datosGuardados.getAttributeAsInt("id"));
								alumnoForm.setValue("version", datosGuardados.getAttributeAsInt("version"));
								alumnoForm.setValue("clave", datosGuardados.getAttributeAsString("clave"));
								

							}
						});

					}

				}
			}
		});
		alumnoForm.setDataSource(alumnoDS);
		hLayout.addMember(alumnoForm);

		VLayout layout = new VLayout();
		layout.setPadding(4);
		layout.setHeight(200);

		// MATRICULACIÓN DE ASIGNATURAS
		// ******************************************

		Label lblNewLabel = new Label("<strong>Asignaturas matriculadas</strong>");
		lblNewLabel.setHeight("20px");
		layout.addMember(lblNewLabel);

		listadoAsignaturas = crearListadoAsignaturas();
		layout.addMember(listadoAsignaturas);

		// limpiar la lista de asignaturas al deseleccionar un alumno
		listadoAlumnos.addSelectionChangedHandler(new SelectionChangedHandler() {

			@Override
			public void onSelectionChanged(SelectionEvent event) {
				if (!event.getState()) {
					listadoAsignaturas.setData(new Record[] {});
				}
			}
		});

		final AsignaturaSelector asignaturaForm = new AsignaturaSelector(true);

		asignaturaForm.addSubmitValuesHandler(new SubmitValuesHandler() {

			@Override
			public void onSubmitValues(SubmitValuesEvent event) {
				// guardar la matricula
				String alumno = alumnoForm.getValueAsString("id");

				if (alumno == null)
					SC.say("Debe seleccionar un alumno para matricular");

				AsignaturaOverlay asigSeleccionada = asignaturaForm.getAsignaturaSeleccionada();
				PersonaServiceUtils.matriculaAsignatura(alumno, asigSeleccionada, new JsonRequestAction() {
					@Override
					public void successAction(Record datosGuardados) {
						// agregar a la lista de asignaturas del alumno
						listadoAsignaturas.addData(asignaturaForm.getAsignaturaSeleccionadaRecord());
						listadoAsignaturas.groupBy("cursoNombre");
					}
				});
			}
		});
		layout.addMember(asignaturaForm);

		hLayout.addMember(layout);

		listadoAlumnos.addRecordClickHandler(new RecordClickHandler() {

			@Override
			public void onRecordClick(RecordClickEvent event) {
				Record seleccionado = listadoAlumnos.getSelectedRecord();

				listadoAsignaturas.setData(new Record[] {});
				listadoAsignaturas.setLoadingDataMessage("Cargando datos");

				// cargar las asignaturas del alumno
				PersonaServiceUtils.obtenerAsignaturasAlumno(new Long(seleccionado.getAttributeAsInt("id")),
						new JsonRequestAction() {
							@Override
							public void actionRecord(Record r) {
								listadoAsignaturas.addData(r);
							}
						});

				alumnoForm.editRecord(seleccionado);
			}

		});

		addMember(edgedCanvas);

		// initWidget(this);
	}

	private ListGrid crearListadoAsignaturas() {
		ListGrid lg = new ListGrid() {
			@Override
			protected Canvas getRollOverCanvas(final Integer rowNum, Integer colNum) {
				Log.debug("rollover" + rowNum);

				rollOverRecord = this.getRecord(rowNum);
				String nombre = rollOverRecord.getAttribute("nombre");
				Log.debug("rollover nombre : " + nombre);

				if (rollOverCanvas == null) {
					rollOverCanvas = new HLayout(3);
					rollOverCanvas.setSnapTo("TR");
					rollOverCanvas.setWidth(10);
					rollOverCanvas.setHeight(22);

					editImg = new ImgButton();
					editImg.setShowDown(false);
					editImg.setShowRollOver(false);
					editImg.setLayoutAlign(Alignment.CENTER);
					editImg.setSrc("[SKIN]/actions/remove.png");
					editImg.setPrompt("Eliminar centro");
					editImg.setHeight(16);
					editImg.setWidth(16);
					editImg.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler() {

						@Override
						public void onClick(com.smartgwt.client.widgets.events.ClickEvent event) {
							String asignaturaId = rollOverRecord.getAttribute("id");
							String nombre = rollOverRecord.getAttribute("nombre");

							if (nombre == null) {
								Log.debug("No eliminando un curso");
								return;
							}

							Log.debug("FIXME ::::: *********** implementar eliminar matricula ");

							final ListGridRecord asignatura;
							for (ListGridRecord r : listadoAsignaturas.getRecords()) {
								if (r.getAttribute("id").equals(asignaturaId)) {

									Log.debug("eliminando " + rowNum);
									Log.debug("eliminando recorde con id " + asignaturaId);

									asignatura = r;
									String alumno = alumnoForm.getValueAsString("id");

									AsignaturaOverlay asignaturaOver = asignatura.getJsObj().cast();
									PersonaServiceUtils.desMatriculaAsignatura(alumno, asignaturaOver,
											new JsonRequestAction() {

												@Override
												public void successAction() {
													listadoAsignaturas.removeData(asignatura);
												};

											});

									break;
								}
							}
						}
					});

					rollOverCanvas.addMember(editImg);
				}

				if (nombre != null)
					editImg.show();
				else
					editImg.hide();

				Log.debug("rollover visible  : " + (nombre != null));

				return rollOverCanvas;
			}
		};
		lg.setShowRollOverCanvas(true);
		lg.setAlternateRecordStyles(true);

		lg.setHeight(190);

		ListGridField listGridField = new ListGridField("cursoNombre", "Curso");
		listGridField.setValueField("cursoNombre");
		ListGridField listGridField_1 = new ListGridField("nombre", "Asignatura");
		listGridField_1.setWidth("75%");
		ListGridField fCursoId = new ListGridField("cursoId", "");
		fCursoId.setHidden(true);

		lg.setShowAllRecords(true);
		lg.setGroupStartOpen(GroupStartOpen.ALL);
		lg.setGroupByField("cursoNombre");
		lg.setGroupIndentSize(50);

		lg.setCanRemoveRecords(false);
		lg.setAnimateRemoveRecord(false);

		lg.setFields(new ListGridField[] { listGridField_1, listGridField, fCursoId });
		lg.sort("cursoId", SortDirection.ASCENDING);

		lg.setEmptyMessage("Sin matrículas");

		return lg;
	}

	public void actualizarAlumnos() {

		// limpiar la lista
		limpiaListado();

		if (Log.isDebugEnabled())
			Log.debug("*** actualizando asignaturas");

		Date now = new Date();
		String url = GWT.getHostPageBaseURL() + "services/api/alumnos/list.json?now=" + now.getTime();

		RequestBuilder builder = new RequestBuilder(RequestBuilder.GET, url);
		builder.setHeader("Pragma", "no-cache");

		try {
			builder.sendRequest(null, new RequestCallback() {
				public void onError(Request request, Throwable exception) {

				}

				public void onResponseReceived(Request request, Response response) {
					if (200 == response.getStatusCode()) {
						try {
							// parse the response text into JSON
							JsArray<PersonaOverlay> data = PersonaOverlay.arrayFromJson(response.getText());

							/*
							 * JSONValue jsonValue = JSONParser
							 * .parseStrict(response.getText()); JSONArray
							 * jsonArray = jsonValue.isArray(); // for
							 * (jsonArray.get)
							 */
							Log.debug(response.getText());

							List<PersonaOverlay> alumnos = new ArrayList<PersonaOverlay>();
							DataClass[] lista = new DataClass[data.length()];
							for (int i = 0; i < data.length(); i++) {
								alumnos.add(data.get(i));
								lista[i] = new DataClass(data.get(i));

								Record r = new Record(data.get(i));

								/*
								 * Log.debug("Asignatura: " +
								 * Arrays.toString(r.getAttributes()));
								 * Log.debug("Asignatura: " + String.valueOf(r
								 * .getAttribute("cursoNombre")));
								 */
								// action for one record
								listadoAlumnos.addData(r);
							}

							// listadoAlumnos.fetchData();

						} catch (JSONException e) {
						}
					} else {

					}
				}
			});
		} catch (RequestException e) {

		}
	}

	public void limpiaListado() {
		alumnoDS.setTestData(new DataClass[] {});
		this.listadoAlumnos.setData(new Record[] {});
	}

	public AsignaturaDatasource getAsignaturasDataSource() {
		return asignaturasDataSource;
	}

	public void setAsignaturasDataSource(AsignaturaDatasource asignaturasDataSource) {
		this.asignaturasDataSource = asignaturasDataSource;
	}

}
