package es.upv.client.ui;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.core.client.GWT;
import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;
import com.google.gwt.http.client.URL;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Element;
import com.google.gwt.user.client.ui.FormPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.smartgwt.client.data.Record;
import com.smartgwt.client.types.Alignment;
import com.smartgwt.client.types.ValidatorType;
import com.smartgwt.client.widgets.Canvas;
import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.Window;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.events.SubmitValuesEvent;
import com.smartgwt.client.widgets.form.events.SubmitValuesHandler;
import com.smartgwt.client.widgets.form.fields.ButtonItem;
import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.PasswordItem;
import com.smartgwt.client.widgets.form.fields.TextItem;
import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
import com.smartgwt.client.widgets.form.validator.Validator;
import com.smartgwt.client.widgets.layout.VLayout;

import es.upv.client.ui.events.UsuarioValidadoEvent;
import es.upv.client.utils.PersonaServiceUtils;
import es.upv.client.utils.JsonRequestAction;
import es.upv.client.utils.TipoAcceso;

public class UsuarioLoginWindow extends Window {

	private TextItem usuField;
	private PasswordItem passField;
	
	public TextBox usuinput;

	public UsuarioLoginWindow() {
		setAutoCenter(true);
		setAutoSize(true);
		setShowHeader(false);
		setTitle("");
		this.setCanDrag(true);
		setPadding(40);
		setShowTitle(false);
		setShowCloseButton(false);
		setCanDrag(false);
		setShowModalMask(true);
		setShowMinimizeButton(false);
		setIsModal(true);

		VLayout layout = new VLayout();
		layout.setMargin(50);

		final DynamicForm loginForm = new DynamicForm();
		loginForm.setWidth(300);
		loginForm.setSaveOnEnter(true);
		
		final ButtonItem submitItem = new ButtonItem();
		submitItem.setColSpan(2);
		submitItem.setTitle("Entrar!");
		submitItem.setAlign(Alignment.RIGHT);
		submitItem.setIcon("[SKIN]/actions/next.png");
		
		final ButtonItem btnCancel = new ButtonItem();
		btnCancel.setTitle("Volver!");
		btnCancel.setColSpan(2);
		btnCancel.setAlign(Alignment.RIGHT);
		btnCancel.setIcon("[SKIN]/actions/back.png");

		Validator validator = new Validator();
		validator.setType(ValidatorType.REQUIRED);

		com.google.gwt.user.client.ui.Label lbl = new com.google.gwt.user.client.ui.Label();
		lbl.setText("Usuario");
		
		usuField = new TextItem("loginNombre", "Nombre");
		usuField.setWidth("*");
		usuField.setValidateOnChange(true);
		usuField.setValidators(validator);
		
		passField = new PasswordItem("loginPass", "Clave");
		passField.setValidateOnChange(true);
		passField.setValidators(validator);
		passField.setWidth("*");
		
		loginForm.setFields(new FormItem[] { usuField, passField, submitItem, btnCancel });
		loginForm.focusInItem(usuField);

		submitItem.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				if (loginForm.validate())
					ejecutarAccionLogin();
			}
		});
		
		btnCancel.addClickHandler(new ClickHandler() {
			
			@Override
			public void onClick(ClickEvent event) {
				Element el = DOM.getElementById("isc_Z");
				focusUsuario(el);
				// com.google.gwt.user.client.Window.Location.assign(GWT.getHostPageBaseURL() + "/Evaltics.html");
				
			}
		});

		loginForm.addSubmitValuesHandler(new SubmitValuesHandler() {

			@Override
			public void onSubmitValues(SubmitValuesEvent event) {
				if (loginForm.validate())
					ejecutarAccionLogin();
			}
		});

		Label lblIcon = new Label ("");
		lblIcon.setIcon("[SKIN]/Dialog/ask.png");
		lblIcon.setIconSize(32);
		lblIcon.setLayoutAlign(Alignment.CENTER);
		layout.addMember(lblIcon);
		lblIcon.setAutoHeight();
		
		Label lblNewLabel = new Label("<h3>Introduzca nombre de usuario y clave para continuar</h3>");
		layout.addMember(lblNewLabel);
		lblNewLabel.setStyleName("defaultLabel");
		lblNewLabel.setSize("100%", "57px");
		lblNewLabel.setWrap(false);
		lblNewLabel.setAlign(Alignment.CENTER);
		
		FormPanel formPanel = new FormPanel();
		layout.addMember(formPanel);
		
		
		VerticalPanel verticalPanel = new VerticalPanel();
		formPanel.setWidget(verticalPanel);
		verticalPanel.setSize("334px", "100%");
		
		com.google.gwt.user.client.ui.Label lblNewLabel_2 = new com.google.gwt.user.client.ui.Label("New label");
		verticalPanel.add(lblNewLabel_2);
		
		usuinput = new TextBox();
		verticalPanel.add(usuinput);
		usuinput.setWidth("100%");
		
		com.google.gwt.user.client.ui.Label lblNewLabel_3 = new com.google.gwt.user.client.ui.Label("New label");
		verticalPanel.add(lblNewLabel_3);
		
		TextBox textBox_1 = new TextBox();
		verticalPanel.add(textBox_1);
		textBox_1.setWidth("100%");
		
		Image image = new Image("sc/skins/Enterprise/images/actions/exclamation.png");
		verticalPanel.add(image);

		layout.addMember(loginForm);
		
		addItem(layout);
		
		// Element el = DOM.getElementById("disconectLink");
		//  focusUsuario (el);
		
		Log.debug( loginForm.getChildren().length +  "<----");
		for (Canvas c : loginForm.getChildren()) {
			Log.debug (c.getID());
		}
		
	}
	
	protected void ejecutarAccionLogin() {

		RequestBuilder request = new RequestBuilder(RequestBuilder.POST, GWT.getHostPageBaseURL() + "j_security_check");
		request.setHeader("Content-Type", "application/x-www-form-urlencoded");

		try {
			request.sendRequest(
					"j_username=" + URL.encode(usuField.getValueAsString()) + "&j_password="
							+ URL.encode(passField.getValueAsString()), new RequestCallback() {

						@Override
						public void onResponseReceived(Request request, Response response) {
							Log.debug("Respuesta j_security_check: " + response.getStatusCode());

							// FIXME : obtener el resultado correcto de
							// alguna manera
							if (response.getText().contains("j_security_check")) {
								// error en la validacion

								Root.EVENT_BUS.fireEvent(new UsuarioValidadoEvent(false, null));
							} else {

								PersonaServiceUtils.validarUsuario(TipoAcceso.ACCESO_ALUMNO, usuField.getValueAsString(),
										passField.getValueAsString(), new JsonRequestAction() {
											@Override
											public void successAction(Record datosGuardados) {

												// lanzar evento
												// logeado!!
												Root.EVENT_BUS
														.fireEvent(new UsuarioValidadoEvent(true, datosGuardados));
											}

											@Override
											public void failureAction() {
												Root.EVENT_BUS.fireEvent(new UsuarioValidadoEvent(false, null));
											}
										});

							}

						}

						@Override
						public void onError(Request request, Throwable exception) {
							com.google.gwt.user.client.Window.alert("Respuesta : " + exception.getLocalizedMessage());

							Root.EVENT_BUS.fireEvent(new UsuarioValidadoEvent(false, null));

						}
					});
		} catch (RequestException e) {
			com.google.gwt.user.client.Window.alert("Error en j_security_check");
		}
		
	}
	
	public void desconectar () {
		Log.debug("desconectar");
		com.google.gwt.user.client.Window.alert("Desconectando!!!");
	}
	
	public native void focusUsuario(Element el) /*-{
	
		el.focus() ;
		
		console.log (document.getElementsByName('loginNombre').length);
		console.log (document.getElementById('isc_Z'));
		
		if (false) {
			console.log (el.tagName);
			console.log(document.getElementsByName('loginNombre')[0]);
			if (document.getElementsByName('loginNombre').length > 0 ) 
	    		console.log(document.getElementsByName('loginNombre')[0].focus());
    	}
	}-*/;
	

}
