package es.upv.client.ui.correccion;

import java.util.List;

import com.allen_sauer.gwt.log.client.Log;
import com.smartgwt.client.types.Alignment;
import com.smartgwt.client.widgets.Label;

import es.upv.shared.dto.RespuestaAlumno;
import es.upv.shared.dto.RespuestaPregunta;
import es.upv.shared.dto.RespuestaPreguntaOM;

public class PanelCorreccionOM extends PanelCorreccionRespuesta {

	private Label lblRespuestaAlumno;
	private Label lblRespuestaCorrecta;
	
	private RespuestaAlumno respuestaAlumno;

	public PanelCorreccionOM() {
		setWidth100();

		lblRespuestaAlumno = new Label("");
		lblRespuestaAlumno.setAlign(Alignment.CENTER);
		addMember(lblRespuestaAlumno);

		lblRespuestaCorrecta = new Label("");
		lblRespuestaCorrecta.setAlign(Alignment.CENTER);
		addMember(lblRespuestaCorrecta);
	}

	@Override
	public void setRespuestaAlumno(RespuestaAlumno respuesta) {

		respuestaAlumno = respuesta;

	}

	@Override
	public void setRespuestaCorrecta(List<RespuestaPregunta> respuesta) {
		Log.debug("*********************" + respuestaAlumno.getOm());
		if (respuesta != null && !respuesta.isEmpty()) {
			
			String respuestaStr = "La respuesta del alumno es : <br><h3> (Sin respuesta) </h3>";
			for (RespuestaPregunta r : respuesta) {
				if (r instanceof RespuestaPreguntaOM) {
					RespuestaPreguntaOM rOM = (RespuestaPreguntaOM) r;
					
					if (rOM.getCorrecta()) { 
						lblRespuestaCorrecta.setContents("La respuesta correcta es : <br> <h3>" + rOM.getRespuesta() + "</h3>");
					}
					
					if (respuestaAlumno.getOm() != null && rOM.getId().equals(Long.valueOf(respuestaAlumno.getOm()))) {
						respuestaStr = "La respuesta correcta es : <br> <h3>" + rOM.getRespuesta() + "</h3>";
					}
				}
			}
			
			lblRespuestaAlumno.setContents(respuestaStr);
			
		} else {
			Log.debug ("Sin respuesta ");
		}
	}
}
