package es.upv.client.ui.correccion;

import java.util.List;

import com.allen_sauer.gwt.log.client.Log;
import com.smartgwt.client.types.Alignment;
import com.smartgwt.client.widgets.Label;

import es.upv.shared.dto.RespuestaAlumno;
import es.upv.shared.dto.RespuestaPregunta;
import es.upv.shared.dto.RespuestaPreguntaVF;

public class PanelCorreccionVF extends PanelCorreccionRespuesta {

	private Label lblRespuestaAlumno;
	private Label lblRespuestaCorrecta;

	public PanelCorreccionVF() {
		setWidth100();

		lblRespuestaAlumno = new Label("");
		lblRespuestaAlumno.setAlign(Alignment.CENTER);
		addMember(lblRespuestaAlumno);

		lblRespuestaCorrecta = new Label("");
		lblRespuestaCorrecta.setAlign(Alignment.CENTER);
		addMember(lblRespuestaCorrecta);
	}

	@Override
	public void setRespuestaAlumno(RespuestaAlumno respuesta) {

		if (Boolean.TRUE.equals(respuesta.getVf())) {
			lblRespuestaAlumno.setContents("La respuesta del alumno es : <br><h3> Verdadero </h3>");
		} else if (Boolean.TRUE.equals(respuesta.getVf()))
			lblRespuestaAlumno.setContents("La respuesta del alumno es :  <br><h3>Falso </h3>");
		else
			lblRespuestaAlumno.setContents("La respuesta del alumno es : <br><h3> (Sin respuesta) </h3>");

	}

	@Override
	public void setRespuestaCorrecta(List<RespuestaPregunta> respuesta) {
		Log.debug("*********************");
		if (respuesta != null && !respuesta.isEmpty()) {
			if (respuesta.get(0) instanceof RespuestaPreguntaVF) {
				RespuestaPreguntaVF respuestaVF = (RespuestaPreguntaVF) respuesta.get(0);
				lblRespuestaCorrecta.setContents("La respuesta correcta es "
						+ (Boolean.TRUE.equals(respuestaVF.getCorrecta()) ? "<h3>VERDADERO</h3>" : (Boolean.FALSE
								.equals(respuestaVF.getCorrecta()) ? "<h3>FALSO</h3>" : "<h3>DESCONOCIDO</h3>")));
			} else 
				Log.debug("Respuesta no es de este tipo");
		} else {
			Log.debug ("Sin respuesta ");
		}
	}
}
