package es.upv.client.ui.ds;

import com.google.gwt.core.client.GWT;
import com.smartgwt.client.data.DataSourceField;
import com.smartgwt.client.types.DSDataFormat;
import com.smartgwt.client.types.FieldType;


public class AsignaturaDatasource extends DatasourceEvaltics {
	
	public AsignaturaDatasource() {
		this.setDataURL((GWT.getHostPageBaseURL() + "services/api/asignaturas/list.json"));
		this.setDataFormat(DSDataFormat.JSON);
		
		DataSourceField fId = new DataSourceField ("id", FieldType.INTEGER);
		fId.setPrimaryKey(true);
		fId.setHidden(true);
		addField(fId);
		
		DataSourceField fVersion = new DataSourceField ("version", FieldType.INTEGER);
		fVersion.setHidden(true);
		addField(fVersion);
		
		nuevoCampoRequerido("nombre", FieldType.TEXT);
		nuevoCampoRequerido("siglas", FieldType.TEXT);
		nuevoCampoRequerido("codigo", FieldType.TEXT);
		nuevoCampoRequerido("descripcion", FieldType.TEXT);
		
		nuevoCampoRequerido("cursoId", FieldType.INTEGER);
		nuevoCampoRequerido("centroId", FieldType.INTEGER);
		
		addField(new DataSourceField ("cursoNombre", FieldType.TEXT));
		addField(new DataSourceField ("centroNombre", FieldType.TEXT));
		
		addField(new DataSourceField ("credTeoria", FieldType.FLOAT));
		addField(new DataSourceField ("credLaboratorio", FieldType.FLOAT));
		
		this.setClientOnly(true);
	}

}
