package es.upv.client.ui.ds;

import com.smartgwt.client.data.DataSource;
import com.smartgwt.client.data.DataSourceField;
import com.smartgwt.client.types.FieldType;
import com.smartgwt.client.types.ValidatorType;
import com.smartgwt.client.widgets.form.validator.Validator;

public class DatasourceEvaltics extends DataSource {
	
	private static Validator requiredValidator;
	
	public DatasourceEvaltics () {
		// Log.debug("Setting client only");
		this.setClientOnly(true);
		
		requiredValidator = new Validator ();
		requiredValidator.setType(ValidatorType.REQUIRED);
	}
	
	/**
	 * Agrega campos con un tipo definido 
	 * 
	 * @param fields
	 * @param tipo
	 */
	public void agregaCamposRequeridos (String[] fields, FieldType tipo) {
		
		Validator required = new Validator();
		required.setType(ValidatorType.REQUIRED);
		
		for (String f : fields)
			nuevoCampoRequerido(f, tipo);
			
	}
	
	public void nuevoCampoRequerido (String field, FieldType tipo) {
		DataSourceField dsf = new DataSourceField(field, tipo);
		dsf.setValidators(requiredValidator);
		
		this.addField(dsf);
	}
	
}
