package es.upv.client.ui.panelrespuesta;

import java.util.LinkedHashMap;
import java.util.List;

import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.RadioGroupItem;

import es.upv.shared.dto.RespuestaAlumno;
import es.upv.shared.dto.RespuestaPregunta;
import es.upv.shared.dto.RespuestaPreguntaOM;

public class PanelRespuestaTipoOM extends PanelRespuestaBase {

	private RadioGroupItem respuestasRadio;

	public PanelRespuestaTipoOM(List<RespuestaPregunta> opciones) {

		respuestasRadio = new RadioGroupItem("radioOpciones", "");
		respuestasRadio.setShowTitle(false);

		LinkedHashMap<String, String> valueMap = new LinkedHashMap<String, String>();

		for (RespuestaPregunta respuesta : opciones) {
			RespuestaPreguntaOM opcion = (RespuestaPreguntaOM) respuesta;
			valueMap.put(opcion.getId().toString(), opcion.getRespuesta());
		}
		respuestasRadio.setValueMap(valueMap);

		setFields(new FormItem[] { respuestasRadio });
	}

	@Override
	public boolean contieneRespuesta() {
		return respuestasRadio.getValue() != null;
	}

	@Override
	public void actualizaRespuesta(RespuestaAlumno respuestaActual) {
		respuestaActual.setOm(Integer.valueOf(respuestasRadio.getValueAsString()));
	}

	@Override
	public void setRespuesta(Integer integer) {
		respuestasRadio.setValue(String.valueOf(integer));
	}

}
