package es.upv.client.ui.panelrespuesta;

import java.util.LinkedHashMap;

import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.RadioGroupItem;

import es.upv.shared.dto.Pregunta;
import es.upv.shared.dto.RespuestaAlumno;

public class PanelRespuestaTipoVF extends PanelRespuestaBase {

	private static final String VALOR_RESPUESTA_FALSO = "1";
	private static final String VALOR_RESPUESTA_VERDADERO = "0";

	private RadioGroupItem respuestasRadio;

	public PanelRespuestaTipoVF(Pregunta pregunta) {

		setHeight100();

		respuestasRadio = new RadioGroupItem("radioOpciones", "");
		respuestasRadio.setShowTitle(false);

		LinkedHashMap<String, String> valueMap = new LinkedHashMap<String, String>();
		valueMap.put(VALOR_RESPUESTA_VERDADERO, "Verdadero");
		valueMap.put(VALOR_RESPUESTA_FALSO, "Falso");
		respuestasRadio.setValueMap(valueMap);

		setFields(new FormItem[] { respuestasRadio });
	}

	@Override
	public boolean contieneRespuesta() {
		return respuestasRadio.getValue() != null;
	}

	@Override
	public void actualizaRespuesta(RespuestaAlumno respuestaActual) {
		if (VALOR_RESPUESTA_VERDADERO.equals(respuestasRadio.getValueAsString())) {
			respuestaActual.setVf(true);
		} else
			respuestaActual.setVf(false);
	}

	@Override
	public void setRespuesta(Boolean respuesta) {

		if (Boolean.TRUE.equals(respuesta))
			respuestasRadio.setValue(VALOR_RESPUESTA_VERDADERO);
		else if (Boolean.FALSE.equals(respuesta))
			respuestasRadio.setValue(VALOR_RESPUESTA_FALSO);

	}

}
