package es.upv.client.ui.respuestas;

import java.util.List;

import com.smartgwt.client.types.Alignment;
import com.smartgwt.client.widgets.IButton;
import com.smartgwt.client.widgets.layout.VLayout;

import es.upv.client.ui.Root;
import es.upv.client.ui.events.GuardarRespuestasEvent;
import es.upv.shared.dto.RespuestaPregunta;

public abstract class PanelDefinicionRespuestasBase extends VLayout {
	public abstract String identificadorTipo ();
	
	public abstract void cargarRespuestas (List<RespuestaPregunta> result);
	
	public void guardarRespuestas (List<RespuestaPregunta> respuestas) {
		GuardarRespuestasEvent ev = new GuardarRespuestasEvent();
		ev.setRespuestas (respuestas);
		
		Root.EVENT_BUS.fireEvent(ev);
	}
	
	protected IButton creaBotonGuardar() {
		IButton btnGuardar = new IButton("Guardar");
		btnGuardar.setLayoutAlign(Alignment.CENTER);
		btnGuardar.setKeepInParentRect(true);
		
		btnGuardar.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler() {
			
			@Override
			public void onClick(com.smartgwt.client.widgets.events.ClickEvent event) {
				
				List<RespuestaPregunta> respuestas = obtieneRespuestasAGuardar ();;
				
				guardarRespuestas (respuestas);
			}
		});
		
		return btnGuardar;
	}

	protected abstract List<RespuestaPregunta> obtieneRespuestasAGuardar();
}
