/**
 * 
 */
package es.upv.client.ui.respuestas;

import java.util.ArrayList;
import java.util.List;

import com.smartgwt.client.types.ListGridFieldType;
import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.fields.ButtonItem;
import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.TextAreaItem;
import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
import com.smartgwt.client.widgets.grid.ListGrid;
import com.smartgwt.client.widgets.grid.ListGridField;
import com.smartgwt.client.widgets.grid.ListGridRecord;
import com.smartgwt.client.widgets.layout.LayoutSpacer;

import es.upv.shared.dto.RespuestaPregunta;
import es.upv.shared.dto.RespuestaPreguntaOM;

/**
 * @author jsc
 * 
 */
public class PanelDefinicionRespuestasOM extends PanelDefinicionRespuestasBase {

	private ListGrid listadoRespuestas;
	private DynamicForm formNuevaOpcion;
	
	public PanelDefinicionRespuestasOM() {
		setPadding(10);
		setMembersMargin(5);

		Label lblopcionesAElegir = new Label("<h3>Opciones a elegir</h3>");
		lblopcionesAElegir.setHeight("24px");
		addMember(lblopcionesAElegir);

		listadoRespuestas = creaListado();
		addMember(listadoRespuestas);

		formNuevaOpcion = new DynamicForm();
		formNuevaOpcion.setPadding(10);
		formNuevaOpcion.setIsGroup(true);
		formNuevaOpcion.setGroupTitle("Nueva opción");
		formNuevaOpcion.setWidth("100%");
		formNuevaOpcion.setNumCols(2);

		formNuevaOpcion.setColWidths("*", 50);
		TextAreaItem textAreaItem = new TextAreaItem("respuesta", "Nueva opción");
		textAreaItem.setWidth("*");
		textAreaItem.setHeight(50);
		textAreaItem.setColSpan(1);
		textAreaItem.setShowTitle(false);
		textAreaItem.setEndRow(false);
		ButtonItem addItem = new ButtonItem("addbutton", "Añadir");
		addItem.setStartRow(false);

		addItem.addClickHandler(new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {
				if (formNuevaOpcion.validate()) {
					listadoRespuestas.addData(formNuevaOpcion.getValuesAsRecord());
					formNuevaOpcion.clearValues();
					formNuevaOpcion.focusInItem("respuesta");
				}
			}
		});
		formNuevaOpcion.setFields(new FormItem[] { textAreaItem, addItem });
		addMember(formNuevaOpcion);

		LayoutSpacer layoutSpacer = new LayoutSpacer();
		layoutSpacer.setHeight("20");
		addMember(layoutSpacer);

		addMember(creaBotonGuardar ());
	}

	@Override
	protected List<RespuestaPregunta> obtieneRespuestasAGuardar() {
		List<RespuestaPregunta>  respuestasGuardar  = new ArrayList<RespuestaPregunta>();
		
		// para cada una de las entradas en el grid, crear una respuetas
		for (ListGridRecord opcion : listadoRespuestas.getRecords()) {
			RespuestaPreguntaOM om = new RespuestaPreguntaOM();
			
			om.setId( new Long( opcion.getAttributeAsInt("id") ) );
			om.setRespuesta( opcion.getAttribute("respuesta"));
			om.setCorrecta( opcion.getAttributeAsBoolean("correcto"));
			om.setVersion( opcion.getAttributeAsInt ("version"));
			
			// om.setPreguntaId(pregunta.getId());
			
			respuestasGuardar.add(om);
		}
		
		return respuestasGuardar;
	}

	private ListGrid creaListado() {
		ListGrid lg = new ListGrid();
		
		lg.setCanRemoveRecords(true);
		lg.setHeight("161px");
		lg.setCanRemoveRecords(true);
		ListGridField idField = new ListGridField("id");
		idField.setHidden(true);
		ListGridField listGridField = new ListGridField("correcto", "Correcto");
		listGridField.setCanEdit(true);
		listGridField.setType(ListGridFieldType.BOOLEAN);
		ListGridField fVersion = new ListGridField("version");
		fVersion.setHidden(true);
		lg.setFields(new ListGridField[] { idField, new ListGridField("respuesta", "Opción"), listGridField, fVersion});

		return lg;
	}

	@Override
	public String identificadorTipo() {
		return "OM";
	}

	@Override
	public void cargarRespuestas(List<RespuestaPregunta> respuestas) {
		listadoRespuestas.setData(new ListGridRecord[] {});
		
		for (RespuestaPregunta respuesta : respuestas) {
			RespuestaPreguntaOM respuestaOM = (RespuestaPreguntaOM) respuesta;
			
			ListGridRecord r = new ListGridRecord();
			r.setAttribute("id", respuestaOM.getId().intValue());
			r.setAttribute("respuesta", respuestaOM.getRespuesta());
			r.setAttribute("correcto", respuestaOM.getCorrecta());
			r.setAttribute("version", respuestaOM.getVersion().intValue());
			
			listadoRespuestas.addData(r);
		}
	}

}
