/**
 * 
 */
package es.upv.client.ui.respuestas;

import java.util.ArrayList;
import java.util.List;

import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.RichTextItem;

import es.upv.shared.dto.RespuestaPregunta;
import es.upv.shared.dto.RespuestaPreguntaRL;

/**
 * @author jsc
 * 
 */
public class PanelDefinicionRespuestasRL extends PanelDefinicionRespuestasBase {

	private DynamicForm formRespuestaPosible;
	private RespuestaPreguntaRL respuesta = null;

	@Override
	public String identificadorTipo() {
		return "RL";
	}

	public PanelDefinicionRespuestasRL() {

		setMembersMargin(4);

		Label lblTitulo = new Label("<h3>Posible respuesta</h3>");
		lblTitulo.setHeight("24px");
		addMember(lblTitulo);

		formRespuestaPosible = new DynamicForm();
		// dynamicForm.setHeight("100%");
		RichTextItem rich = new RichTextItem("respuesta", "");
		rich.setHeight(200);
		rich.setWidth("*");
		rich.setCellStyle("richTextItem");
		formRespuestaPosible.setFields(new FormItem[] { rich });
		addMember(formRespuestaPosible);

		addMember(creaBotonGuardar());
	}

	@Override
	public void cargarRespuestas(List<RespuestaPregunta> result) {
		if (result != null && !result.isEmpty()) {
			respuesta = (RespuestaPreguntaRL) result.get(0);

			formRespuestaPosible.setValue("respuesta", respuesta.getRespuestaPosible());
		} else
			respuesta = null;
	}

	@Override
	protected List<RespuestaPregunta> obtieneRespuestasAGuardar() {
		
		// si se ha cargado alguna respuesta, actualizarla, si no crear una nueva para deolverla
		if (respuesta == null) { 
			// crear una nueva
			respuesta = new RespuestaPreguntaRL();
		}

		respuesta.setRespuestaPosible(formRespuestaPosible.getValueAsString("respuesta"));

		List<RespuestaPregunta> lRespuestas = new ArrayList<RespuestaPregunta>();
		lRespuestas.add(respuesta);
		
		return lRespuestas;
	}
}
