/**
 * 
 */
package es.upv.client.ui.respuestas;

import java.util.ArrayList;
import java.util.List;

import com.smartgwt.client.types.Alignment;
import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.fields.FormItem;
import com.smartgwt.client.widgets.form.fields.RadioGroupItem;

import es.upv.shared.dto.RespuestaPregunta;
import es.upv.shared.dto.RespuestaPreguntaVF;


/**
 * @author jsc
 *
 */
public class PanelDefinicionRespuestasVF extends PanelDefinicionRespuestasBase {
	private static final String OPCION_FALSO = "Falso";
	private static final String OPCION_VERDADERO = "Verdadero";
	
	private DynamicForm opcionesForm;
	private RadioGroupItem radioOpciones;
	
	private RespuestaPreguntaVF respuesta;
	
	@Override
	public String identificadorTipo() {
		return "VF";
	}

	
	public PanelDefinicionRespuestasVF () {
		
		setMembersMargin(5);
		
		Label lbllaRespuestaA = new Label("<h3>La respuesta a la pregunta es : </h3>");
		lbllaRespuestaA.setHeight("24px");
		addMember(lbllaRespuestaA);
		
		opcionesForm = new DynamicForm();
		opcionesForm.setWidth("292px");
		radioOpciones = new RadioGroupItem("opciones", "");
		radioOpciones.setShowTitle(false);
		radioOpciones.setValueMap(new String[] {OPCION_VERDADERO, OPCION_FALSO});
		opcionesForm.setFields(new FormItem[] { radioOpciones});
		
		opcionesForm.setLayoutAlign(Alignment.CENTER);
		addMember(opcionesForm);
		
		addMember(creaBotonGuardar());
		
	}


	@Override
	public void cargarRespuestas(List<RespuestaPregunta> result) {
		if (result != null && ! result.isEmpty()) {
			respuesta = (RespuestaPreguntaVF) result.get(0);

			if (Boolean.TRUE.equals(respuesta.getCorrecta())) {
				radioOpciones.setValue(OPCION_VERDADERO);
			} else if (Boolean.FALSE.equals(respuesta.getCorrecta())) {
				radioOpciones.setValue (OPCION_FALSO);
			} else 
				radioOpciones.clearValue();
		}
	}

	@Override
	protected List<RespuestaPregunta> obtieneRespuestasAGuardar() {
		if (respuesta == null) 
			respuesta = new RespuestaPreguntaVF();
		
		if (OPCION_VERDADERO.equals(radioOpciones.getValueAsString())) 
			respuesta.setCorrecta(true);
		else if (OPCION_FALSO.equals(radioOpciones.getValueAsString()))
			respuesta.setCorrecta(false);
		else 
			respuesta.setCorrecta(null);
		
		List<RespuestaPregunta> lRespuestas = new ArrayList<RespuestaPregunta>();
		lRespuestas.add(respuesta);
		
		return lRespuestas;
	}
}
