package es.upv.client.utils;

import com.google.gwt.core.client.GWT;
import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;
import com.google.gwt.json.client.JSONObject;
import com.smartgwt.client.data.Record;
import com.smartgwt.client.util.SC;

import es.upv.shared.model.AsignaturaOverlay;

public class AsignaturaServiceUtils extends BaseServiceUtils {

	public static void guardarAsignatura(Record datosAsignatura, final JsonRequestAction successAction) {

		// obtener los valores del form y enviarlo a guardar
		// test guardar
		String urlsave = GWT.getHostPageBaseURL() + "services/api/asignaturas/save.json";
		RequestBuilder builder2 = new RequestBuilder(RequestBuilder.POST, urlsave);
		builder2.setHeader("Content-Type", "application/json");
		builder2.setHeader("Pragma", "no-cache");

		try {
			JSONObject nuevaAsignatura = new JSONObject(datosAsignatura.getJsObj());
			builder2.sendRequest(nuevaAsignatura.toString(), new RequestCallback() {

				@Override
				public void onResponseReceived(Request request, Response response) {

					if (response.getStatusCode() == Response.SC_OK) {
						AsignaturaOverlay asignaturaGuardada = AsignaturaOverlay.fromJson(response.getText());

						// ejecutar la accion de correcto
						successAction.successAction(new Record(asignaturaGuardada));
					} else
						successAction.failureAction();
				}

				@Override
				public void onError(Request request, Throwable exception) {
					SC.warn("Error al guardar la asignatura");
				}
			});
		} catch (RequestException e) {
			SC.warn("Error al guardar la asignatura");
		}
	}

	public static void borrarAsignatura(String asignaturaId, final JsonRequestAction successAction) {

		borrarEntidad("asignaturas", "borrar", asignaturaId, successAction);

	}
}
