package es.upv.client.utils;

import com.google.gwt.core.client.GWT;
import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;
import com.smartgwt.client.util.SC;

public class BaseServiceUtils {

	public static void borrarEntidad(String servicio, String operacion, String idEntidad,
			final JsonRequestAction successAction) {
		// obtener los valores del form y enviarlo a
		// guardar
		String urlremove = GWT.getHostPageBaseURL() + "services/api/" + servicio + "/" + operacion + "/" + idEntidad
				+ ".json";
		RequestBuilder builder2 = new RequestBuilder(RequestBuilder.POST, urlremove);
		builder2.setHeader("Content-Type", "application/json");
		builder2.setHeader("Pragma", "no-cache");

		try {
			builder2.sendRequest(null, new RequestCallback() {

				@Override
				public void onResponseReceived(Request request, Response response) {
					
					if (response.getStatusCode() != Response.SC_OK) {
						SC.warn("Error al eliminar el elemento");
						successAction.failureAction();
					} else {
						// ejecutar la accion de
						// correcto
						successAction.successAction();
					}
				}

				@Override
				public void onError(Request request, Throwable exception) {
					SC.warn("Error al eliminar el elemento");
				}
			});
		} catch (RequestException e) {
			SC.warn("Error al eliminar el elemento");
		}
	}

}
