package es.upv.client.utils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.core.client.GWT;
import com.google.gwt.core.client.JsArray;
import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;
import com.google.gwt.json.client.JSONArray;
import com.google.gwt.json.client.JSONException;
import com.google.gwt.json.client.JSONParser;
import com.google.gwt.json.client.JSONValue;
import com.smartgwt.client.core.DataClass;
import com.smartgwt.client.data.DataSource;
import com.smartgwt.client.widgets.Label;

import es.upv.shared.model.CentroOverlay;
import es.upv.shared.model.CursoOverlay;

public class CentroServiceUtils {

	public static void obtenerCentros(final Label lblNewLabel_4, final JsonRequestAction actions) {

		Date now = new Date();
		String url = GWT.getHostPageBaseURL() + "services/api/centros/list.json?now=" + now.getTime();

		RequestBuilder builder = new RequestBuilder(RequestBuilder.GET, url);
		builder.setHeader("Pragma", "no-cache");

		Log.debug(GWT.getHostPageBaseURL());
		Log.debug(GWT.getModuleBaseURL());

		try {
			builder.sendRequest(null, new RequestCallback() {
				public void onError(Request request, Throwable exception) {

					if (lblNewLabel_4 != null)
						lblNewLabel_4.setContents("Couldn't retrieve JSON");
				}

				public void onResponseReceived(Request request, Response response) {
					if (200 == response.getStatusCode()) {
						try {
							// parse the response text into JSON
							JsArray<CentroOverlay> data = CentroOverlay.arrayFromJson(response.getText());
							JSONValue jsonValue = JSONParser.parseStrict(response.getText());
							JSONArray jsonArray = jsonValue.isArray();
							// for (jsonArray.get)

							List<CentroOverlay> centros = new ArrayList<CentroOverlay>();
							for (int i = 0; i < data.length(); i++) {
								centros.add(data.get(i));

								DataSource ds = new DataSource();
								ds.setClientOnly(true);
								ds.setTestData(new DataClass[] { new DataClass(data.get(i)) });

								// action for one record
								actions.actionRecord(data.get(i));
							}

							// all records action
							actions.resultsAction(centros);

							if (lblNewLabel_4 != null)
								lblNewLabel_4.setContents("Recibidos " + jsonArray.size() + " elementos por json");
							// JavaScriptObject obj =
							// jsonArray.get(0).isObject().getJavaScriptObject();
							// Window.alert(centros.get(0).getFullName());

						} catch (JSONException e) {
							if (lblNewLabel_4 != null)
								lblNewLabel_4.setContents("Could not parse JSON");
						}
					} else {
						if (lblNewLabel_4 != null)
							lblNewLabel_4.setContents("Couldn't retrieve JSON (" + response.getStatusText() + ")");
					}
				}
			});
		} catch (RequestException e) {
			if (lblNewLabel_4 != null)
				lblNewLabel_4.setContents("Couldn't retrieve JSON");
		}

	}

	public static void obtenerCursos(final Label lblNewLabel_4, final JsonRequestAction actions) {

		Date now = new Date();
		String url = GWT.getHostPageBaseURL() + "services/api/cursos/list.json?now=" + now.getTime();

		RequestBuilder builder = new RequestBuilder(RequestBuilder.GET, url);
		builder.setHeader("Pragma", "no-cache");

		try {
			builder.sendRequest(null, new RequestCallback() {
				public void onError(Request request, Throwable exception) {

					if (lblNewLabel_4 != null)
						lblNewLabel_4.setContents("Couldn't retrieve JSON");
				}

				public void onResponseReceived(Request request, Response response) {
					if (200 == response.getStatusCode()) {
						try {
							// parse the response text into JSON
							JsArray<CursoOverlay> data = CursoOverlay.arrayFromJson(response.getText());
							// for (jsonArray.get)

							List<CursoOverlay> cursos = new ArrayList<CursoOverlay>();
							for (int i = 0; i < data.length(); i++) {
								cursos.add(data.get(i));

								// action for one record
								actions.actionRecord(data.get(i));
							}

							// all records action
							actions.resultsAction(cursos);

						} catch (JSONException e) {
							if (lblNewLabel_4 != null)
								lblNewLabel_4.setContents("Could not parse JSON");
						}
					} else {
						if (lblNewLabel_4 != null)
							lblNewLabel_4.setContents("Couldn't retrieve JSON (" + response.getStatusText() + ")");
					}
				}
			});
		} catch (RequestException e) {
			if (lblNewLabel_4 != null)
				lblNewLabel_4.setContents("Couldn't retrieve JSON");
		}

	}
	
}
