package es.upv.server.dao.hibernate;

import java.util.List;
import java.util.Map;

import org.springframework.dao.DataAccessException;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Repository;

import es.upv.server.dao.AutorDao;
import es.upv.server.model.Usuario;
import es.upv.shared.model.Autor;

@Repository("autorDao")
public class AutorDaoHibernate extends GenericDaoHibernate<Autor, Long> implements AutorDao {

	public AutorDaoHibernate() {
		super(Autor.class);
	}

	@Override
	public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException, DataAccessException {

		Map<String, Object> params = new java.util.HashMap<String, Object>();
		params.put("usuario", username);
		List<Autor> result = findByNamedQuery("obtenerAutorPorUsuario", params);

		if (result != null && !result.isEmpty()) {
			Usuario us = new Usuario(username);
			us.usuarioEsProfesor();
			us.setId(result.get(0).getId());
			us.setClave(result.get(0).getClave());
			return us;
		} else {
			// busacar como profesor
			throw new UsernameNotFoundException(username);
		}
	}
	
}
