package es.upv.server.model;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.GrantedAuthorityImpl;
import org.springframework.security.core.userdetails.UserDetails;

public class Usuario implements java.io.Serializable, UserDetails {
	private static final String PERFIL_USUARIO = "ROLE_ALUMNO";
	private static final String PERFIL_PROFESOR = "ROLE_PROFESOR";

	private static final String ROLE_USER = "ROLE_USER";

	private static final long serialVersionUID = -6117080143867538835L;

	private Long id;
	private String usuario;
	private String clave;
	Set<GrantedAuthority> roles = new HashSet<GrantedAuthority>();

	public Usuario() {
	}

	public Usuario(String username) {
		this.usuario = username;
	}
	
	public Long getId () {
		return this.id;
	}
	
	public void setId (Long id) {
		this.id = id;
	}

	public String getUsuario() {
		return usuario;
	}

	public void setUsuario(String usuario) {
		this.usuario = usuario;
	}

	public String getClave() {
		return clave;
	}

	public void setClave(String clave) {
		this.clave = clave;
	}

	@Override
	public Collection<GrantedAuthority> getAuthorities() {
		return roles;
	}
	
	public void usuarioEsAlumno () {
		this.roles.add(new GrantedAuthorityImpl(ROLE_USER));
		this.roles.add(new GrantedAuthorityImpl(PERFIL_USUARIO));
	}
	
	public void usuarioEsProfesor () {
		this.roles.add(new GrantedAuthorityImpl(ROLE_USER));
		this.roles.add(new GrantedAuthorityImpl(PERFIL_PROFESOR));
	}

	@Override
	public String getPassword() {
		return getClave();
	}

	@Override
	public String getUsername() {
		return getUsuario();
	}

	@Override
	public boolean isAccountNonExpired() {
		return true;
	}

	@Override
	public boolean isAccountNonLocked() {
		return true;
	}

	@Override
	public boolean isCredentialsNonExpired() {
		return true;
	}

	@Override
	public boolean isEnabled() {
		return true;
	}
	
}