package es.upv.server.security.web;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.security.access.AccessDeniedException;
import org.springframework.security.web.WebAttributes;
import org.springframework.security.web.access.AccessDeniedHandlerImpl;

import es.upv.client.security.web.EvalticsForbiddenException;

public class EvalticsAccessDeniedHandler extends AccessDeniedHandlerImpl {
	
	@Override
	public void handle(HttpServletRequest request, HttpServletResponse response,
			AccessDeniedException accessDeniedException) throws IOException, ServletException {
		
		request.setAttribute(WebAttributes.ACCESS_DENIED_403, accessDeniedException);
		
		response.setStatus(HttpServletResponse.SC_FORBIDDEN);
		throw new EvalticsForbiddenException("Acceso denegado");
	}

}
