package es.upv.server.service;

import java.util.List;

import javax.jws.WebService;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

import es.upv.shared.model.Alumno;
import es.upv.shared.model.Asignatura;
import es.upv.shared.model.Persona;

@WebService
@Path("/alumnos")
public interface AlumnoManager {
	
	@Path("/list")
	@GET
	@Produces(MediaType.APPLICATION_JSON)   
	List<Alumno> list();
	
	@Path("/save")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	Alumno saveAlumno (Alumno alumno);
	
	@Path("/validarUsuario")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	Alumno validarUsuario (Persona  alumno);

	@Path("/{alumnId}/asignaturas")
	@GET
	@Produces(MediaType.APPLICATION_JSON)   
	List<Asignatura> asignaturasAlumno(@PathParam("alumnId") Long id);
	
	@Path("/{alumnId}/nuevaMatricula")
	@POST
	@Produces(MediaType.APPLICATION_JSON)
	void nuevaMatricula (@PathParam("alumnId") Long alumnId, @QueryParam("asig") Long asignaturaId);
	
	@Path("/{alumnId}/desmatricula")
	void desmatricula (@PathParam("alumnId") Long alumnId, @QueryParam("asig") Long asignaturaId);
	
	@Path("/borrar/{alumnoId}")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	void borrarAlumno (@PathParam("alumnoId") Long alumnoId);

}
