package es.upv.server.service;

import java.util.List;

import javax.jws.WebService;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import es.upv.shared.model.Asignatura;

@WebService
@Path("/asignaturas")
public interface AsignaturaManager {

	Asignatura get(Long asignaturaId);
	
	@Path("/list")
	@GET
	@Produces(MediaType.APPLICATION_JSON)   
	List<Asignatura> list();
	
	@Path("/save")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	Asignatura saveAsignatura (Asignatura c);

	List<Asignatura> obtenerAsignaturasAlumno (Long alumnId);

	@Path("/borrar/{asignaturaId}")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	void borrarAsignatura (@PathParam("asignaturaId") Long asignaturaId);
	
}
