package es.upv.server.service;

import java.util.List;

import javax.jws.WebService;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import es.upv.shared.model.Autor;
import es.upv.shared.model.Persona;

@WebService
@Path("/autores")
public interface AutorManager {
	
	@Path("/list")
	@GET
	@Produces(MediaType.APPLICATION_JSON)   
	List<Autor> list();
	
	@Path("/save")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	Autor saveAutor (Autor autor);
	
	@Path("/validarUsuario")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	Autor validarUsuario (Persona autor);

	@Path("/borrar/{autorId}")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	void borrarAutor (@PathParam("autorId") Long autorId);

}
