package es.upv.server.service;

import java.util.List;

import javax.jws.WebService;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import es.upv.shared.model.Centro;

@WebService
@Path("/centros")
public interface CentroManager {
	
	@Path("/list")
	@GET
	@Produces(MediaType.APPLICATION_JSON)   
	List<Centro> list();
	
	@Path("/save")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	Centro saveCentro (Centro c);
	
	@Path("/delete/{centroId}")
	@POST
	@Consumes({MediaType.APPLICATION_JSON, MediaType.APPLICATION_XML})
	@Produces(MediaType.APPLICATION_JSON)   
	void deleteCentro (@PathParam("centroId") Long centroId);

}
