package es.upv.server.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response.Status;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Service;

import es.upv.server.dao.hibernate.AsignaturaDao;
import es.upv.server.service.AsignaturaManager;
import es.upv.shared.model.Asignatura;

@Service("asignaturaManager")
public class AsignaturaManagerImpl implements AsignaturaManager {

	AsignaturaDao asignaturaDao;

	public AsignaturaDao getAsignaturaDao() {
		return asignaturaDao;
	}

	@Autowired
	public void setAsignaturaDao(AsignaturaDao asignaturaDao) {
		this.asignaturaDao = asignaturaDao;
	}

	@Override
	public Asignatura get(Long asignaturaId) {
		return asignaturaDao.get(asignaturaId);
	}

	@Override
	public List<Asignatura> list() {
		List<Asignatura> list = asignaturaDao.getAll();

		return list;
	}

	@Override
	public Asignatura saveAsignatura(Asignatura a) {
		return asignaturaDao.save(a);
	}

	@Override
	public List<Asignatura> obtenerAsignaturasAlumno(Long alumnId) {
		Map<String, Object> params = new HashMap<String, Object> ();
		
		params.put("alumno", alumnId);
		
		List<Asignatura> result = asignaturaDao.findByNamedQuery("obtenerMatriculasDeAlumno", params);
		return (List<Asignatura>) result;
	}

	@Override
	public void borrarAsignatura(Long asignaturaId) {
		try {
		asignaturaDao.remove(asignaturaId);
		} catch (DataAccessException ex) {
			throw new WebApplicationException(Status.NOT_MODIFIED);
		}
	}

}
