package es.upv.server.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.context.SecurityContext;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Service;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import es.upv.server.service.AlumnoManager;
import es.upv.server.service.AutorManager;
import es.upv.shared.model.Alumno;
import es.upv.shared.model.Autor;
import es.upv.shared.model.Persona;
import es.upv.shared.services.SesionService;

/**
 * The server side implementation of the RPC service.
 */
@Service("sesionService")
public class SesionServiceImpl extends RemoteServiceServlet implements
		SesionService {
	private static final long serialVersionUID = 3638842918053382078L;
	
	@Autowired
	AlumnoManager alumnoManager;
	
	@Autowired
	AutorManager autorManager;

	@Override
	public Boolean desconectarUsuario() {
		SecurityContext context = SecurityContextHolder.getContext();
		
		// desconectar la sesin
		context.setAuthentication(null);
		
		return Boolean.TRUE;
	}

	@Override
	public Alumno validarAlumno(Persona alumno) {
		return alumnoManager.validarUsuario(alumno);
	}

	@Override
	public Autor validarAutor(Persona alumno) {
		return autorManager.validarUsuario(alumno);
	}

}
