package es.upv.shared.dto;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.xml.bind.annotation.XmlRootElement;

import es.upv.shared.model.Alumno;
import es.upv.shared.model.Asignatura;

@Entity
@Table(name = "evaluacion_alumno")
@NamedQueries({@NamedQuery(name="obtenerEvaluacionesAlumno", query="from EvaluacionAlumno where evaluacionID = :evaluacion and alumnoID = :alumno"),
	@NamedQuery(name="obtenerEvaluacionesFinalizadasAsignatura",
	  query="from EvaluacionAlumno where asignaturaID = :asignatura and finalizado = 1 and corregido = 0")})
@XmlRootElement(name = "EvaluacionAlumno", namespace = "http://evaltics.upv.es")
public class EvaluacionAlumno implements java.io.Serializable {
	private static final long serialVersionUID = -2220326179452654175L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "id")
	private Long id;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "evaluacion_id", updatable = false, insertable = false)
	private Evaluacion evaluacion;

	@Column(name = "evaluacion_id")
	private Long evaluacionID;
	
	@Column (name = "fecha")
	private Date fecha;
	
	@Column(name = "nota")
	private Float nota;
	
	@Column (name = "comentarios")
	private String comentarios;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "matricula_alumno_id", updatable = false, insertable = false)
	private Alumno alumno;

	@Column(name = "matricula_alumno_id")
	private Long alumnoID;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "matricula_asignatura_id", updatable = false, insertable = false)
	private Asignatura asignatura;

	@Column(name = "matricula_asignatura_id")
	private Long asignaturaID;
	
	@Column(name = "finalizado")
	private Boolean finalizado;

	@Column(name = "corregido")
	private Boolean corregido;

	@Version
	private Integer version;

	public EvaluacionAlumno() {
	}

	public EvaluacionAlumno(Long id) {
		this.id = id;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Evaluacion getEvaluacion() {
		return evaluacion;
	}

	public void setEvaluacion(Evaluacion evaluacion) {
		this.evaluacion = evaluacion;
	}

	public Long getEvaluacionID() {
		return evaluacionID;
	}

	public void setEvaluacionID(Long evaluacionID) {
		this.evaluacionID = evaluacionID;
	}

	public Date getFecha() {
		return fecha;
	}

	public void setFecha(Date fecha) {
		this.fecha = fecha;
	}

	public Float getNota() {
		return nota;
	}

	public void setNota(Float nota) {
		this.nota = nota;
	}

	public String getComentarios() {
		return comentarios;
	}

	public void setComentarios(String comentarios) {
		this.comentarios = comentarios;
	}

	public Alumno getAlumno() {
		return alumno;
	}

	public void setAlumno(Alumno alumno) {
		this.alumno = alumno;
	}

	public Long getAlumnoID() {
		return alumnoID;
	}

	public void setAlumnoID(Long alumnoID) {
		this.alumnoID = alumnoID;
	}

	public Asignatura getAsignatura() {
		return asignatura;
	}

	public void setAsignatura(Asignatura asignatura) {
		this.asignatura = asignatura;
	}

	public Long getAsignaturaID() {
		return asignaturaID;
	}

	public void setAsignaturaID(Long asignaturaID) {
		this.asignaturaID = asignaturaID;
	}

	public Boolean getFinalizado() {
		return finalizado;
	}

	public void setFinalizado(Boolean finalizado) {
		this.finalizado = finalizado;
	}

	public Boolean getCorregido() {
		return corregido;
	}

	public void setCorregido(Boolean corregido) {
		this.corregido = corregido;
	}

	public Integer getVersion() {
		return this.version;
	}

	public void setVersion(Integer v) {
		this.version = v;
	}

	@Override
	public String toString() {
		return "EvaluacionAlumno [evaluacionID=" + evaluacionID + ", fecha="
				+ fecha + ", alumnoID=" + alumnoID + ", asignaturaID="
				+ asignaturaID + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((alumnoID == null) ? 0 : alumnoID.hashCode());
		result = prime * result
				+ ((asignaturaID == null) ? 0 : asignaturaID.hashCode());
		result = prime * result
				+ ((evaluacionID == null) ? 0 : evaluacionID.hashCode());
		result = prime * result + ((fecha == null) ? 0 : fecha.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		EvaluacionAlumno other = (EvaluacionAlumno) obj;
		if (alumnoID == null) {
			if (other.alumnoID != null)
				return false;
		} else if (!alumnoID.equals(other.alumnoID))
			return false;
		if (asignaturaID == null) {
			if (other.asignaturaID != null)
				return false;
		} else if (!asignaturaID.equals(other.asignaturaID))
			return false;
		if (evaluacionID == null) {
			if (other.evaluacionID != null)
				return false;
		} else if (!evaluacionID.equals(other.evaluacionID))
			return false;
		if (fecha == null) {
			if (other.fecha != null)
				return false;
		} else if (!fecha.equals(other.fecha))
			return false;
		return true;
	}

}