package es.upv.shared.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.xml.bind.annotation.XmlRootElement;

@Entity
@Table(name = "evaluacion_pregunta")
@NamedQueries({@NamedQuery(name="obtenerPreguntasEvaluacion", query="from EvaluacionPregunta where evaluacionID = :evaluacion")})
@XmlRootElement(name = "EvaluacionPregunta", namespace = "http://evaltics.upv.es")
public class EvaluacionPregunta implements java.io.Serializable {
	private static final long serialVersionUID = 8307635165461944200L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "id")
	private Long id;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "evaluacion_id", updatable = false, insertable = false)
	private Evaluacion evaluacion;

	@Column(name = "evaluacion_id")
	private Long evaluacionID;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "pregunta_id", updatable = false, insertable = false)
	private Pregunta pregunta;

	@Column(name = "pregunta_id")
	private Long preguntaID;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "tema_id", updatable = false, insertable = false)
	private TemaAsignatura tema;

	@Column(name = "tema_id")
	private Long temaID;
	
	@Column(name = "pregunta_valor")
	private Float valor;

	@Column(name = "dificultad")
	private Float dificultad;

	@Column(name = "penalizacion")
	private Float penalizacion;

	@Version
	private Integer version;

	public EvaluacionPregunta() {
	}

	public EvaluacionPregunta(Long id) {
		this.id = id;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Evaluacion getEvaluacion() {
		return evaluacion;
	}

	public void setEvaluacion(Evaluacion evaluacion) {
		this.evaluacion = evaluacion;
	}

	public Long getEvaluacionID() {
		return evaluacionID;
	}

	public void setEvaluacionID(Long evaluacionID) {
		this.evaluacionID = evaluacionID;
	}

	public Pregunta getPregunta() {
		return pregunta;
	}

	public void setPregunta(Pregunta pregunta) {
		this.pregunta = pregunta;
	}

	public Long getPreguntaID() {
		return preguntaID;
	}

	public void setPreguntaID(Long preguntaID) {
		this.preguntaID = preguntaID;
	}

	public TemaAsignatura getTema() {
		return tema;
	}

	public Long getTemaID() {
		return temaID;
	}

	public void setTema(TemaAsignatura tema) {
		this.tema = tema;
	}

	public void setTemaID(Long id) {
		this.temaID = id;
	}

	public Float getValor() {
		return valor;
	}

	public void setValor(Float valor) {
		this.valor = valor;
	}

	public Float getDificultad() {
		return dificultad;
	}

	public void setDificultad(Float dificultad) {
		this.dificultad = dificultad;
	}

	public Float getPenalizacion() {
		return penalizacion;
	}

	public void setPenalizacion(Float penalizacion) {
		this.penalizacion = penalizacion;
	}

	public Integer getVersion() {
		return this.version;
	}

	public void setVersion(Integer v) {
		this.version = v;
	}

	@Override
	public String toString() {
		return "EvaluacionPregunta [id=" + id + ", evaluacionID="
				+ evaluacionID + ", preguntaID=" + preguntaID + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((evaluacionID == null) ? 0 : evaluacionID.hashCode());
		result = prime * result
				+ ((preguntaID == null) ? 0 : preguntaID.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		EvaluacionPregunta other = (EvaluacionPregunta) obj;
		if (evaluacionID == null) {
			if (other.evaluacionID != null)
				return false;
		} else if (!evaluacionID.equals(other.evaluacionID))
			return false;
		if (preguntaID == null) {
			if (other.preguntaID != null)
				return false;
		} else if (!preguntaID.equals(other.preguntaID))
			return false;
		return true;
	}


}