package es.upv.shared.dto;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;
import javax.xml.bind.annotation.XmlRootElement;

@Entity
@Table(name = "pregunta")
@XmlRootElement(name = "pregunta", namespace = "http://evaltics.upv.es")
public class Pregunta implements java.io.Serializable {
	private static final long serialVersionUID = 6250021960097784447L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "id")
	private Long id;

	@Column(name = "titulo", nullable = false, length = 128)
	private String titulo;

	@Column(name = "codigo", nullable = false, length = 512)
	private String codigo;

	@Column(name = "enunciado", nullable = false)
	private String enunciado;
	
	@Column(name = "palabras_clave", nullable = true)
	private String palabrasClave;

	@Column(name = "dificultad")
	private Float dificultad;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "fecha_creacion")
	private Date fechaCreacion;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "fecha_modificacion")
	private Date fechaModificacion;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "tipo_id", updatable = false, insertable = false)
	private TipoPregunta tipoPregunta;

	@Column(name = "tipo_id")
	private Long tipoPreguntaID;

	@Version
	private Integer version;

	public Pregunta() {
	}

	public Pregunta(Long id) {
		this.id = id;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getTitulo() {
		return titulo;
	}

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	public String getCodigo() {
		return codigo;
	}

	public void setCodigo(String codigo) {
		this.codigo = codigo;
	}

	public String getEnunciado() {
		return enunciado;
	}

	public void setEnunciado(String enunciado) {
		this.enunciado = enunciado;
	}

	public String getPalabrasClave() {
		return palabrasClave;
	}

	public void setPalabrasClave(String palabrasClave) {
		this.palabrasClave = palabrasClave;
	}

	public Float getDificultad() {
		return dificultad;
	}

	public void setDificultad(Float dificultad) {
		this.dificultad = dificultad;
	}

	public Date getFechaCreacion() {
		return fechaCreacion;
	}

	public void setFechaCreacion(Date fechaCreacion) {
		this.fechaCreacion = fechaCreacion;
	}

	public Date getFechaModificacion() {
		return fechaModificacion;
	}

	public void setFechaModificacion(Date fechaModificacion) {
		this.fechaModificacion = fechaModificacion;
	}

	public TipoPregunta getTipoPregunta() {
		return tipoPregunta;
	}

	public void setTipoPregunta(TipoPregunta tipoPregunta) {
		this.tipoPregunta = tipoPregunta;
	}

	public Long getTipoPreguntaID() {
		return tipoPreguntaID;
	}

	public void setTipoPreguntaID(Long tipoPreguntaID) {
		this.tipoPreguntaID = tipoPreguntaID;
	}

	public Integer getVersion() {
		return this.version;
	}

	public void setVersion(Integer v) {
		this.version = v;
	}

	@Override
	public String toString() {
		return "PreguntaDTO [titulo=" + titulo + ", tipoPregunta="
				+ tipoPreguntaID + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((codigo == null) ? 0 : codigo.hashCode());
		result = prime * result
				+ ((tipoPreguntaID == null) ? 0 : tipoPreguntaID.hashCode());
		result = prime * result + ((titulo == null) ? 0 : titulo.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Pregunta other = (Pregunta) obj;
		if (codigo == null) {
			if (other.codigo != null)
				return false;
		} else if (!codigo.equals(other.codigo))
			return false;
		if (tipoPreguntaID == null) {
			if (other.tipoPreguntaID != null)
				return false;
		} else if (!tipoPreguntaID.equals(other.tipoPreguntaID))
			return false;
		if (titulo == null) {
			if (other.titulo != null)
				return false;
		} else if (!titulo.equals(other.titulo))
			return false;
		return true;
	}

}