package es.upv.shared.dto;

import javax.persistence.AssociationOverride;
import javax.persistence.AssociationOverrides;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlTransient;

import org.codehaus.jackson.annotate.JsonIgnore;


@Entity
@Table(name = "pregunta_tema")
@AssociationOverrides({
	@AssociationOverride(name = "pk.pregunta", joinColumns = @JoinColumn(name = "pregunta_id")),
	@AssociationOverride(name = "pk.temaAsignatura", joinColumns = @JoinColumn(name = "tema_id")) })
@NamedQueries(value={@NamedQuery(name="obtenerPreguntasDeTema", query="select pk.pregunta from PreguntaTema where tema_id = :tema")} )

public class PreguntaTema implements java.io.Serializable {
	private static final long serialVersionUID = -5330779302741597207L;
	
	private PreguntaTemaPK pk = new PreguntaTemaPK ();

	@EmbeddedId
	@JsonIgnore
	@XmlTransient
	public PreguntaTemaPK getPk() {
		return pk;
	}
	
	public void setPk(PreguntaTemaPK pk) {
		this.pk = pk;
	}

	@Transient
	@JsonIgnore
	@XmlTransient
	public Long getPreguntaId () {
		return getPk().getPregunta().getId();
	}
	
	@Transient 
	public Pregunta getPregunta () {
		return getPk().getPregunta();
	}
	
	public void setPregunta (Pregunta a) {
		getPk().setPregunta(a);
	}
	
	@Transient
	@JsonIgnore
	@XmlTransient
	public Long getTemaAsignaturaId () {
		return getPk().getTemaAsignatura().getId();
	}
	
	@Transient 
	public TemaAsignatura getTemaAsignatura () {
		return getPk().getTemaAsignatura();
	}
	
	public void setTemaAsignatura (TemaAsignatura a) {
		getPk().setTemaAsignatura(a);
	}

	@Override
	public String toString() {
		return "Matricula [pk=" + pk + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((pk == null) ? 0 : pk.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PreguntaTema other = (PreguntaTema) obj;
		if (pk == null) {
			if (other.pk != null)
				return false;
		} else if (!pk.equals(other.pk))
			return false;
		return true;
	}
	
}