package es.upv.shared.dto;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Embeddable;
import javax.persistence.ManyToOne;

import org.codehaus.jackson.map.annotate.JsonSerialize;
import org.codehaus.jackson.map.annotate.JsonSerialize.Inclusion;


@Embeddable
@JsonSerialize(include=Inclusion.NON_NULL)
public class PreguntaTemaPK implements Serializable {
	private static final long serialVersionUID = 6960611383296126807L;
	
	private Pregunta pregunta;
	private TemaAsignatura tema;
	
	@ManyToOne(cascade=CascadeType.PERSIST)
	public Pregunta getPregunta () {
		return this.pregunta;
	}
	
	public void setPregunta (Pregunta p) {
		this.pregunta = p;
	}
	
	@ManyToOne(cascade=CascadeType.PERSIST)
	public TemaAsignatura getTemaAsignatura () {
		return this.tema;
	}
	
	public void setTemaAsignatura (TemaAsignatura a) {
		this.tema = a;
	}

	@Override
	public String toString() {
		return "MatriculaPK [Pregunta=" + pregunta + ", TemaAsignatura=" + tema
				+ "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((pregunta == null) ? 0 : pregunta.hashCode());
		result = prime * result
				+ ((tema == null) ? 0 : tema.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PreguntaTemaPK other = (PreguntaTemaPK) obj;
		if (pregunta == null) {
			if (other.pregunta != null)
				return false;
		} else if (!pregunta.equals(other.pregunta))
			return false;
		if (tema == null) {
			if (other.tema != null)
				return false;
		} else if (!tema.equals(other.tema))
			return false;
		return true;
	}

	
}
