package es.upv.shared.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.xml.bind.annotation.XmlRootElement;

@Entity
@Table(name = "respuesta_alumno")
@NamedQueries({@NamedQuery(name="obtenerRespuestasEvaluacionAlumno", 
                           query="from RespuestaAlumno where evaluacionAlumnoID = :evaluacion")})
@XmlRootElement(name = "RespuestaAlumno", namespace = "http://evaltics.upv.es")
public class RespuestaAlumno implements java.io.Serializable {
	private static final long serialVersionUID = -2220326179452654175L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "id")
	private Long id;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "evaluacion_alumno_id", updatable = false, insertable = false)
	private EvaluacionAlumno evaluacionAlumno;

	@Column(name = "evaluacion_alumno_id")
	private Long evaluacionAlumnoID;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "evaluacion_pregunta_id", updatable = false, insertable = false)
	private EvaluacionPregunta evaluacionPregunta;

	@Column(name = "evaluacion_pregunta_id")
	private Long evaluacionPreguntaID;

	@Column(name = "vf")
	private Boolean vf;

	@Column(name = "om")
	private Integer om;

	@Column(name = "rl")
	private String rl;

	@Column(name = "nota")
	private Float nota;

	@Column(name = "grado_confianza")
	private Integer gradoConfianza;

	@Version
	private Integer version;

	public RespuestaAlumno() {
	}

	public RespuestaAlumno(Long id) {
		this.id = id;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public EvaluacionAlumno getEvaluacionAlumno() {
		return evaluacionAlumno;
	}

	public void setEvaluacionAlumno(EvaluacionAlumno evaluacionAlumno) {
		this.evaluacionAlumno = evaluacionAlumno;
	}

	public Long getEvaluacionAlumnoID() {
		return evaluacionAlumnoID;
	}

	public void setEvaluacionAlumnoID(Long evaluacionAlumnoID) {
		this.evaluacionAlumnoID = evaluacionAlumnoID;
	}

	public EvaluacionPregunta getEvaluacionPregunta() {
		return evaluacionPregunta;
	}

	public void setEvaluacionPregunta(EvaluacionPregunta evaluacionPregunta) {
		this.evaluacionPregunta = evaluacionPregunta;
	}

	public Long getEvaluacionPreguntaID() {
		return evaluacionPreguntaID;
	}

	public void setEvaluacionPreguntaID(Long evaluacionPreguntaID) {
		this.evaluacionPreguntaID = evaluacionPreguntaID;
	}

	public Boolean getVf() {
		return vf;
	}

	public void setVf(Boolean vf) {
		this.vf = vf;
	}

	public Integer getOm() {
		return om;
	}

	public void setOm(Integer om) {
		this.om = om;
	}

	public String getRl() {
		return rl;
	}

	public void setRl(String rl) {
		this.rl = rl;
	}

	public Float getNota() {
		return nota;
	}

	public void setNota(Float nota) {
		this.nota = nota;
	}

	public Integer getGradoConfianza() {
		return gradoConfianza;
	}

	public void setGradoConfianza(Integer gradoConfianza) {
		this.gradoConfianza = gradoConfianza;
	}

	public Integer getVersion() {
		return this.version;
	}

	public void setVersion(Integer v) {
		this.version = v;
	}

	@Override
	public String toString() {
		return "RespuestaAlumno [evaluacionAlumnoID=" + evaluacionAlumnoID
				+ ", evaluacionPreguntaID=" + evaluacionPreguntaID + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime
				* result
				+ ((evaluacionAlumnoID == null) ? 0 : evaluacionAlumnoID
						.hashCode());
		result = prime
				* result
				+ ((evaluacionPreguntaID == null) ? 0 : evaluacionPreguntaID
						.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RespuestaAlumno other = (RespuestaAlumno) obj;
		if (evaluacionAlumnoID == null) {
			if (other.evaluacionAlumnoID != null)
				return false;
		} else if (!evaluacionAlumnoID.equals(other.evaluacionAlumnoID))
			return false;
		if (evaluacionPreguntaID == null) {
			if (other.evaluacionPreguntaID != null)
				return false;
		} else if (!evaluacionPreguntaID.equals(other.evaluacionPreguntaID))
			return false;
		return true;
	}

}