package es.upv.shared.dto;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Version;

@Entity
@Table(name="pregunta_respuesta")
@Inheritance(strategy=InheritanceType.JOINED)
@NamedQueries({@NamedQuery(name="obtenerRespuestasPregunta", query="from RespuestaPregunta where preguntaId = :pregunta")})
public class RespuestaPregunta implements Serializable {
	private static final long serialVersionUID = 5638240664964662484L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "id")
	private Long id;
	
	@Column(name="pregunta_id")
	private Long preguntaId;
	
	@Column(name="refuerzo_positivo")
	private String refuerzoPositivo;
	
	@Column(name="refuerzo_negativo")
	private String refuerzoNegativo;
	
	@Version
	private Integer version;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getPreguntaId() {
		return preguntaId;
	}

	public void setPreguntaId(Long preguntaId) {
		this.preguntaId = preguntaId;
	}

	public String getRefuerzoPositivo() {
		return refuerzoPositivo;
	}

	public void setRefuerzoPositivo(String refuerzoPositivo) {
		this.refuerzoPositivo = refuerzoPositivo;
	}

	public String getRefuerzoNegativo() {
		return refuerzoNegativo;
	}

	public void setRefuerzoNegativo(String refuerzoNegativo) {
		this.refuerzoNegativo = refuerzoNegativo;
	}

	public Integer getVersion() {
		return version;
	}

	public void setVersion(Integer version) {
		this.version = version;
	}

	@Override
	public String toString() {
		return "RespuestaPregunta [id=" + id + ", preguntaId=" + preguntaId + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((preguntaId == null) ? 0 : preguntaId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RespuestaPregunta other = (RespuestaPregunta) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (preguntaId == null) {
			if (other.preguntaId != null)
				return false;
		} else if (!preguntaId.equals(other.preguntaId))
			return false;
		return true;
	}
	
}
