package es.upv.shared.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Version;

import es.upv.shared.model.Asignatura;

@Entity
@Table(name = "tema")
@NamedQueries(value = { 
		@NamedQuery(name = "obtenerTemasDeAsignatura", query = "from TemaAsignatura where asignaturaID = :asignatura") })
public class TemaAsignatura implements java.io.Serializable {
	private static final long serialVersionUID = -7867417961135019058L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "id")
	private Long id;

	@Column(name = "nombre", nullable = false, length = 128)
	private String nombre;

	@Column(name = "numero_tema", nullable = false)
	private Integer numero_tema;

	@Column(name = "descripcion")
	private String descripcion;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "asignatura_id", updatable = false, insertable = false)
	private Asignatura asignatura;

	@Column(name = "asignatura_id")
	private Long asignaturaID;

	@Version
	private Integer version;

	public TemaAsignatura() {
	}

	public TemaAsignatura(Long id) {
		this.id = id;
	}

	public TemaAsignatura(Long id, String nombre, Integer numero_tema,
			String descripcion, Long asignaturaId) {
		this.id = id;
		this.nombre = nombre;
		this.descripcion = descripcion;
		this.numero_tema = numero_tema;
		this.asignaturaID = asignaturaId;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public Integer getNumero_tema() {
		return numero_tema;
	}

	public void setNumero_tema(Integer numero_tema) {
		this.numero_tema = numero_tema;
	}

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	public Asignatura getAsignatura() {
		return asignatura;
	}

	public void setAsignatura(Asignatura asignatura) {
		this.asignatura = asignatura;
	}

	public Long getAsignaturaID() {
		return asignaturaID;
	}

	public void setAsignaturaID(Long asignaturaID) {
		this.asignaturaID = asignaturaID;
	}

	public Integer getVersion() {
		return version;
	}

	public void setVersion(Integer version) {
		this.version = version;
	}

	@Override
	public String toString() {
		return "TemaAsignaturaDTO [nombre=" + nombre + ", numero_tema="
				+ numero_tema + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((asignaturaID == null) ? 0 : asignaturaID.hashCode());
		result = prime * result + ((nombre == null) ? 0 : nombre.hashCode());
		result = prime * result
				+ ((numero_tema == null) ? 0 : numero_tema.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TemaAsignatura other = (TemaAsignatura) obj;
		if (asignaturaID == null) {
			if (other.asignaturaID != null)
				return false;
		} else if (!asignaturaID.equals(other.asignaturaID))
			return false;
		if (nombre == null) {
			if (other.nombre != null)
				return false;
		} else if (!nombre.equals(other.nombre))
			return false;
		if (numero_tema == null) {
			if (other.numero_tema != null)
				return false;
		} else if (!numero_tema.equals(other.numero_tema))
			return false;
		return true;
	}

}