package es.upv.shared.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Version;

import org.codehaus.jackson.annotate.JsonIgnoreProperties;

@Entity
@Table(name = "alumno")
@NamedQueries(value = { @NamedQuery(name = "obtenerAlumnoPorUsuario", query = "from Alumno where usuario = :usuario") ,
						@NamedQuery(name = "obtenerPasswordUsuario", query = "select clave from Alumno where id = :idalumno")})
@JsonIgnoreProperties(ignoreUnknown = true)
public class Alumno implements java.io.Serializable {
	private static final long serialVersionUID = -6117080143867538835L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "id")
	private Long id;

	@Column(name = "dni", nullable = false, length = 16)
	private String dni;

	@Column(name = "primerNombre", nullable = false, length = 64)
	private String primerNombre;

	@Column(name = "segundoNombre", nullable = true, length = 64)
	private String segundoNombre;

	@Column(name = "apellidoPaterno", nullable = false, length = 64)
	// !!! en Espa�a, el apellido paterno ya no tiene preferencia para ser el
	// primero
	private String apellidoPaterno;

	@Column(name = "apellidoMaterno", length = 64)
	private String apellidoMaterno;

	@Column(name = "direccion", nullable = false)
	private String direccion;

	@Column(name = "telefono", nullable = false, length = 64)
	private String telefono;

	@Column(name = "movilA", length = 64)
	private String movil;

	@Column(name = "usuario", nullable = false, length = 256)
	private String usuario;

	@Column(name = "clave", nullable = false, length = 256)
	private String clave;

	@Column(name = "email", nullable = false, length = 128)
	private String email;

	@Version
	private Integer version;

	public Alumno() {
	}

	public Alumno(Long id) {
		this.id = id;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getDni() {
		return dni;
	}

	public void setDni(String dni) {
		this.dni = dni;
	}

	public String getPrimerNombre() {
		return primerNombre;
	}

	public void setPrimerNombre(String primerNombre) {
		this.primerNombre = primerNombre;
	}

	public String getSegundoNombre() {
		return segundoNombre;
	}

	public void setSegundoNombre(String segundoNombre) {
		this.segundoNombre = segundoNombre;
	}

	public String getApellidoPaterno() {
		return apellidoPaterno;
	}

	public void setApellidoPaterno(String apellidoPaterno) {
		this.apellidoPaterno = apellidoPaterno;
	}

	public String getApellidoMaterno() {
		return apellidoMaterno;
	}

	public void setApellidoMaterno(String apellidoMaterno) {
		this.apellidoMaterno = apellidoMaterno;
	}

	public String getDireccion() {
		return direccion;
	}

	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}

	public String getTelefono() {
		return telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	public String getMovil() {
		return movil;
	}

	public void setMovil(String movil) {
		this.movil = movil;
	}

	public String getUsuario() {
		return usuario;
	}

	public void setUsuario(String usuario) {
		this.usuario = usuario;
	}

	public String getClave() {
		return clave;
	}

	public void setClave(String clave) {
		this.clave = clave;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public Integer getVersion() {
		return this.version;
	}

	public void setVersion(Integer v) {
		this.version = v;
	}

	@Override
	public String toString() {
		return "Centro [id=" + id + ", nombre=" + primerNombre + ", usuario=" + usuario + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((dni == null) ? 0 : dni.hashCode());
		result = prime * result + ((email == null) ? 0 : email.hashCode());
		result = prime * result + ((usuario == null) ? 0 : usuario.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Alumno other = (Alumno) obj;
		if (dni == null) {
			if (other.dni != null)
				return false;
		} else if (!dni.equals(other.dni))
			return false;
		if (email == null) {
			if (other.email != null)
				return false;
		} else if (!email.equals(other.email))
			return false;
		if (usuario == null) {
			if (other.usuario != null)
				return false;
		} else if (!usuario.equals(other.usuario))
			return false;
		return true;
	}

}