package es.upv.shared.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

import org.codehaus.jackson.annotate.JsonIgnoreProperties;

@Entity
@Table(name = "autor")
@NamedQueries(value = { @NamedQuery(name = "obtenerAutorPorUsuario", query = "from Autor where usuario = :usuario"),
		@NamedQuery(name = "obtenerPasswordAutor", query = "select clave from Autor where id = :idautor") })
@XmlRootElement(name = "Autor", namespace = "http://evaltics.upv.es")
@JsonIgnoreProperties(ignoreUnknown = true)
public class Autor extends Persona {
	private static final long serialVersionUID = -5163064247180440632L;

	@Column(name = "despacho")
	private String despacho;

	public Autor() {
	}

	public Autor(Long id) {
		this.setId(id);
	}

	public String getDespacho() {
		return despacho;
	}

	public void setDespacho(String despacho) {
		this.despacho = despacho;
	}

	@Override
	public String toString() {
		return "Autor [id=" + getId() + ", nombre=" + getPrimerNombre() + ", usuario=" + getUsuario() + "]";
	}

}