package es.upv.shared.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.xml.bind.annotation.XmlRootElement;

@Entity
@Table(name = "centro")
@XmlRootElement(name = "Centro", namespace = "http://evaltics.upv.es")
public class Centro implements java.io.Serializable {
	private static final long serialVersionUID = -5006916269856510592L;

	@Id
	@GeneratedValue(strategy=GenerationType.AUTO)
	@Column(name = "id")
	private Long id;

	@Column(name = "nombre", nullable = false, length = 128)
	private String nombre;

	@Column(name = "siglas", nullable = false, length = 48)
	private String siglas;

	@Column(name = "descripcion")
	private String descripcion;
	
	@Version
	private Integer version;
	

	public Centro() {
	}

	public Centro(Long id) {
		this.id = id;
	}

	public Centro(Long id, String nombre, String siglas, String descripcion) {
		this.id = id;
		this.nombre = nombre;
		this.siglas = siglas;
		this.descripcion = descripcion;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getSiglas() {
		return siglas;
	}

	public void setSiglas(String siglas) {
		this.siglas = siglas;
	}

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}
	
	public Integer getVersion () {
		return this.version;
	}
	
	public void setVersion (Integer v) {
		this.version = v;
	}
	
	@Override
	public String toString() {
		return "Centro [id=" + id + ", nombre=" + nombre + ", siglas=" + siglas
				+ ", descripcion=" + descripcion + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((nombre == null) ? 0 : nombre.hashCode());
		result = prime * result + ((siglas == null) ? 0 : siglas.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Centro other = (Centro) obj;
		if (nombre == null) {
			if (other.nombre != null)
				return false;
		} else if (!nombre.equals(other.nombre))
			return false;
		if (siglas == null) {
			if (other.siglas != null)
				return false;
		} else if (!siglas.equals(other.siglas))
			return false;
		return true;
	}
	
	
}