package es.upv.shared.model;

import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.core.client.JsArray;

public class CentroOverlay extends JavaScriptObject {

	// Overlay types always have protected, zero-arg ctors
	protected CentroOverlay() {
	}

	// Typically, methods on overlay types are JSNI
	public final native int getId() /*-{
		return this.id;
	}-*/;

	// Typically, methods on overlay types are JSNI
	public final native String getNombre() /*-{
		return this.nombre;
	}-*/;

	// Typically, methods on overlay types are JSNI
	public final native String getDescripcion() /*-{
		return this.descripcion;
	}-*/;

	public final native String getSiglas() /*-{
		return this.siglas;
	}-*/;

	public final native int getVersion() /*-{
		return this.version;
	}-*/;

	// Note, though, that methods aren't required to be JSNI
	public final String getFullName() {
		return getNombre() + " ( " + getSiglas() + " )";
	}

	public static native JsArray<CentroOverlay> arrayFromJson(String jsonString) /*-{
		return eval('(' + jsonString + ')');
	}-*/;

	public static native CentroOverlay fromJson(String jsonString) /*-{
		return eval('(' + jsonString + ')');
	}-*/;

}
