package es.upv.shared.model;

import javax.persistence.AssociationOverride;
import javax.persistence.AssociationOverrides;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.JoinColumn;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

import org.codehaus.jackson.annotate.JsonIgnore;

@Entity
@Table(name = "matricula")
@AssociationOverrides({
	@AssociationOverride(name = "pk.alumno", joinColumns = @JoinColumn(name = "alumno_id")),
	@AssociationOverride(name = "pk.asignatura", joinColumns = @JoinColumn(name = "asignatura_id")) })
@NamedQueries(value={@NamedQuery(name="obtenerMatriculasDeAlumno", query="select pk.asignatura from Matricula where alumno_id = :alumno")} )
@XmlRootElement(name = "Matricula", namespace = "http://evaltics.upv.es")
public class Matricula implements java.io.Serializable {
	private static final long serialVersionUID = 8925033640356318368L;
	
	private MatriculaPK pk = new MatriculaPK ();


	@EmbeddedId
	@JsonIgnore
	@XmlTransient
	public MatriculaPK getPk() {
		return pk;
	}
	
	public void setPk(MatriculaPK pk) {
		this.pk = pk;
	}

	@Transient
	@JsonIgnore
	@XmlTransient
	public Long getAlumnoId () {
		return getPk().getAlumno().getId();
	}
	
	@Transient 
	public Alumno getAlumno () {
		return getPk().getAlumno();
	}
	
	public void setAlumno (Alumno a) {
		getPk().setAlumno(a);
	}
	
	@Transient
	@JsonIgnore
	@XmlTransient
	public Long getAsignaturaId () {
		return getPk().getAsignatura().getId();
	}
	
	@Transient 
	public Asignatura getAsignatura () {
		return getPk().getAsignatura();
	}
	
	public void setAsignatura (Asignatura a) {
		getPk().setAsignatura(a);
	}

	@Override
	public String toString() {
		return "Matricula [pk=" + pk + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((pk == null) ? 0 : pk.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Matricula other = (Matricula) obj;
		if (pk == null) {
			if (other.pk != null)
				return false;
		} else if (!pk.equals(other.pk))
			return false;
		return true;
	}
	
}