package es.upv.shared.model;

import java.io.Serializable;

import javax.persistence.Embeddable;
import javax.persistence.ManyToOne;

import org.codehaus.jackson.map.annotate.JsonSerialize;
import org.codehaus.jackson.map.annotate.JsonSerialize.Inclusion;

@Embeddable
@JsonSerialize(include=Inclusion.NON_NULL)
public class MatriculaPK implements Serializable {
	private static final long serialVersionUID = 6960611383296126807L;
	
	private Alumno alumno;
	private Asignatura asignatura;
	
	@ManyToOne
	public Alumno getAlumno () {
		return this.alumno;
	}
	
	public void setAlumno (Alumno a) {
		this.alumno = a;
	}
	
	@ManyToOne
	public Asignatura getAsignatura () {
		return this.asignatura;
	}
	
	public void setAsignatura (Asignatura a) {
		this.asignatura = a;
	}

	@Override
	public String toString() {
		return "MatriculaPK [alumno=" + alumno + ", asignatura=" + asignatura
				+ "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((alumno == null) ? 0 : alumno.hashCode());
		result = prime * result
				+ ((asignatura == null) ? 0 : asignatura.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		MatriculaPK other = (MatriculaPK) obj;
		if (alumno == null) {
			if (other.alumno != null)
				return false;
		} else if (!alumno.equals(other.alumno))
			return false;
		if (asignatura == null) {
			if (other.asignatura != null)
				return false;
		} else if (!asignatura.equals(other.asignatura))
			return false;
		return true;
	}

	
}
