package es.upv.shared.services;

import java.util.List;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

import es.upv.shared.dto.Employee;

public interface EmployeeServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see com.javacodegeeks.gwtspring.shared.services.EmployeeService
     */
    void findEmployee( long employeeId, AsyncCallback<es.upv.shared.dto.Employee> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see com.javacodegeeks.gwtspring.shared.services.EmployeeService
     */
    void saveEmployee( long employeeId, java.lang.String name, java.lang.String surname, java.lang.String jobDescription, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see com.javacodegeeks.gwtspring.shared.services.EmployeeService
     */
    void updateEmployee( long employeeId, java.lang.String name, java.lang.String surname, java.lang.String jobDescription, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see com.javacodegeeks.gwtspring.shared.services.EmployeeService
     */
    void saveOrUpdateEmployee( long employeeId, java.lang.String name, java.lang.String surname, java.lang.String jobDescription, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see com.javacodegeeks.gwtspring.shared.services.EmployeeService
     */
    void deleteEmployee( long employeeId, AsyncCallback<Void> callback );
    
    void getAll(AsyncCallback<List<Employee>> callback);


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static EmployeeServiceAsync instance;

        public static final EmployeeServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (EmployeeServiceAsync) GWT.create( EmployeeService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "springGwtServices/employeeService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
	
}
