package es.upv.shared.services;

import java.util.List;

import org.springframework.security.access.annotation.Secured;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

import es.upv.shared.dto.Evaluacion;
import es.upv.shared.dto.EvaluacionAlumno;
import es.upv.shared.dto.EvaluacionPregunta;
import es.upv.shared.dto.RespuestaAlumno;

@RemoteServiceRelativePath("springGwtServices/evaluacionService")
public interface EvaluacionService extends RemoteService {
	
	public Evaluacion guardarEvaluacion(Evaluacion tema) throws Exception;
	
	public void guardarPreguntasEvaluacion (Long evaluacionID, List<EvaluacionPregunta> preguntas);
	
	public void obtenerEvaluacionesPublicadasAsignatura (Long asignaturaID);
	
	@Secured(value={"ROLE_ALUMNO"})
	public List<Evaluacion> obtenerEvaluacionesPendientesAlumno (Long alumnoID) throws es.upv.client.security.web.EvalticsForbiddenException;
	
	public EvaluacionAlumno obtenerEvaluacionAlumno (Long alumnoID, Long evaluacionID);
	
	public List<RespuestaAlumno> obtenerPreguntasEvaluacionAlumno (Long evaluacionAlumnoID);
	
	public EvaluacionAlumno comenzarEvaluacion (Long alumnoID, Long evaluacionID);
	
	public RespuestaAlumno guardaRespuesta (Long evaluacionAlumnoID, RespuestaAlumno respuesta);
	
	public List<EvaluacionAlumno> obtenerEvaluacionesRealizadasAsignatura (Long asignaturaID);
	
	public void finalizarEvaluacion (Long evaluacionID);
	
}
