package es.upv.shared.services;

import java.util.List;

import org.springframework.security.access.annotation.Secured;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

import es.upv.shared.dto.Evaluacion;
import es.upv.shared.dto.EvaluacionAlumno;
import es.upv.shared.dto.EvaluacionPregunta;
import es.upv.shared.dto.RespuestaAlumno;

public interface EvaluacionServiceAsync {

	void guardarEvaluacion(Evaluacion tema, AsyncCallback<Evaluacion> callback);

	void guardarPreguntasEvaluacion(Long evaluacionID,
			List<EvaluacionPregunta> preguntas, AsyncCallback<Void> callback);

	@Secured(value={"ROLE_ALUMNO"})
	void obtenerEvaluacionesPendientesAlumno(Long alumnoID,
			AsyncCallback<List<Evaluacion>> callback);

	void obtenerEvaluacionesPublicadasAsignatura(Long asignaturaID,
			AsyncCallback<Void> callback);
	
    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static EvaluacionServiceAsync instance;

        public static final EvaluacionServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (EvaluacionServiceAsync) GWT.create( EvaluacionService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "springGwtServices/evaluacionService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }

	void obtenerEvaluacionAlumno(Long alumnoID, Long evaluacionID,
			AsyncCallback<EvaluacionAlumno> callback);

	void comenzarEvaluacion(Long alumnoID, Long evaluacionID, AsyncCallback<EvaluacionAlumno> callback);

	void obtenerPreguntasEvaluacionAlumno(Long evaluacionAlumnoID,
			AsyncCallback<List<RespuestaAlumno>> callback);

	void guardaRespuesta(Long evaluacionAlumnoID, RespuestaAlumno respuesta, AsyncCallback<RespuestaAlumno> callback);

	void obtenerEvaluacionesRealizadasAsignatura(Long asignaturaID, AsyncCallback<List<EvaluacionAlumno>> callback);

	void finalizarEvaluacion(Long evaluacionID, AsyncCallback<Void> callback);
}
