package es.upv.shared.services;

import java.util.List;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

import es.upv.shared.dto.RespuestaPregunta;
import es.upv.shared.dto.TipoPregunta;

public interface PreguntasServiceAsync {

	void obtenerTiposPregunta(AsyncCallback<List<TipoPregunta>> callback);
	
	void obtenerRespuestasPregunta(Long preguntaId, AsyncCallback<List<RespuestaPregunta>> callback);
	
	
	
	 /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static PreguntasServiceAsync instance;

        public static final PreguntasServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (PreguntasServiceAsync) GWT.create( PreguntasService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "springGwtServices/preguntasService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }



	void eliminaTipoPregunta(Long tipoPreguntaId, AsyncCallback<Void> callback);

	void actualizaTipoPregunta(TipoPregunta tipoPregunta, AsyncCallback<TipoPregunta> callback);

	void guardarRespuestasPregunta(Long preguntaId, List<RespuestaPregunta> respuestas,
			AsyncCallback<List<RespuestaPregunta>> callback);

	void eliminarRespuestasPregunta(Long preguntaId, AsyncCallback<Void> callback);

}
