package es.upv.shared.services;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

import es.upv.shared.model.Alumno;
import es.upv.shared.model.Autor;
import es.upv.shared.model.Persona;

public interface SesionServiceAsync {

	 /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static SesionServiceAsync instance;

        public static final SesionServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (SesionServiceAsync) GWT.create( SesionService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "springGwtServices/sesionService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }

	void validarAutor(Persona alumno, AsyncCallback<Autor> callback);

	void validarAlumno(Persona alumno, AsyncCallback<Alumno> callback);
	
	void desconectarUsuario(AsyncCallback<Boolean> callback);
}
