/**
 * 
 */
package es.upv.shared.services;

import java.util.List;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

import es.upv.shared.dto.Pregunta;
import es.upv.shared.dto.TemaAsignatura;

/**
 * @author jsc
 *
 */
public interface TemaAsignaturaServiceAsync {

	/**
	 * 
	 * @see es.upv.shared.services.TemaAsignaturaService#deleteTema(long)
	 */
	void deleteTema(long temaId, AsyncCallback<Void> callback);

	/**
	 * 
	 * @see es.upv.shared.services.TemaAsignaturaService#get(long)
	 */
	void get(long temaId, AsyncCallback<TemaAsignatura> callback);

	/**
	 * 
	 * @see es.upv.shared.services.TemaAsignaturaService#obtenerTemasAsignatura(long)
	 */
	void obtenerTemasAsignatura(long asignaturaId,
			AsyncCallback<List<TemaAsignatura>> callback);

	/**
	 * 
	 * @see es.upv.shared.services.TemaAsignaturaService#saveTema(es.upv.shared.dto.TemaAsignatura)
	 */
	void saveTema(TemaAsignatura tema,
			AsyncCallback<TemaAsignatura> callback);
	

    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static TemaAsignaturaServiceAsync instance;

        public static final TemaAsignaturaServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (TemaAsignaturaServiceAsync) GWT.create( TemaAsignaturaService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "springGwtServices/temaAsignaturaServicee" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }


	void obtenerPreguntasTema(long temaId,
			AsyncCallback<List<Pregunta>> callback);

	void guardaPreguntaDeTema(long temaId, Pregunta pregunta,
			AsyncCallback<Pregunta> callback);

	void eliminaPreguntaTema(long temaId, long preguntaid, AsyncCallback<Void> callback);

}
